-- Dungeon Tactics
-- Copyright 2012 lukas w. irwin [ lukas.w.irwin@gmail.com ]
-- This program is free software under the terms of the GNU General Public License version 3 or later.
-- alert.lua

alert = { ID = 0 }

-- print "[alert]"

-- creation
function alert:new (o)
	-- print "[alert] new alert"
	o = o or {}
	setmetatable(o, self)
	self.__index = self

	btn_w = 128
	btn_h = 30

	x = screen_width/2-128
	y = 20
	alert_window = sim:addWindow( 500, xcore.x2drect(x, y, x+256, y+98), "System Alert")
	alert_window:setTitleBarVisible( false )

	
	texture_background_alert = sim:getTexture( path .. "/resources/interface/frame_256x64.png" )
	image_background_alert = sim:addImage( 0, texture_background_alert, xcore.x2dpoint(0, 0),
		xcore.x2drect(0,0,64,64), xcore.xcolour(255,255,255,255) )
	image_background_alert:setParent( alert_window )
	
	-- text
	x = 8
	y = 6
	text_alert = sim:addText( 0, "Do you really want to quit?", x, y, x+256-8, y+48)
	text_alert:setParent( alert_window )			
	text_alert:setAlignment(2, 0)

	x = 0
	y = 68
	-- add some buttons
	button_alert_accept = sim:addButton( 501, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Yes" )
	button_alert_accept:setParent( alert_window )	
	button_alert_accept:setImage( button_texture )
	button_alert_accept:setPressedImage( button_pressed_texture )	

	x = x+ 128
	button_alert_cancel = sim:addButton( 502, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "No" )
	button_alert_cancel:setParent( alert_window )
	button_alert_cancel:setImage( button_texture )
	button_alert_cancel:setPressedImage( button_pressed_texture )	

	sim:bindGUI ( "button_alert_accept_pressed", 501, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "button_alert_cancel_pressed", 502, xcore.XGUI_BUTTON_CLICKED )
	
	self:hide()
	return o
end

function alert:hide()
	-- print "[alert] hide"
	alert_window:setVisible( false )
end

function alert:show()
	-- print "[alert] show"
	alert_window:setVisible( true )
	-- print "[alert] /show"
end

function alert:destroy()
	-- print "[alert] destroy"
	alert_window:destroy()
end

function alert:setText( t )
	-- print "[alert] update unit alert"
	text_alert:setText( t )
end

-- end of file