-- Dungeon Tactics
-- Copyright 2012 lukas w. irwin [ lukas.w.irwin@gmail.com ]
-- This program is free software under the terms of the GNU General Public License version 3 or later.
-- edit_abilities.lua

edit_abilities = { ID = 0 }

-- print "[edit_abilities]"

-- creation
function edit_abilities:new (o)
	-- print "[edit_abilities] new edit_abilities"
	o = o or {}
	setmetatable(o, self)
	self.__index = self

	btn_w = 60
	btn_h = 30

	--
	-- list window
	--
	x = 10
	y = 60
	window_edit_abilities_list = sim:addWindow( 1000, xcore.x2drect(x, y, x+128, y+256+60), "Ability List")
	window_edit_abilities_list:setTitleBarVisible( false )		
	image_background_edit_list = sim:addImage( 0, texture_background_128x256, xcore.x2dpoint(0, 0),
		xcore.x2drect(0,0,64,64), xcore.xcolour(255,255,255,255) )
	image_background_edit_list:setParent( window_edit_abilities_list )

	-- list
	width = 118	
	x = 5
	y = 10
	height = 236
	listbox_edit_abilities = sim:addListbox( 1010, true, xcore.x2drect( x,y,x+width,y+height ) )
	listbox_edit_abilities:setParent( window_edit_abilities_list )
	listbox_edit_abilities:addItem("test")

	x = 0
	y = 256
	-- add some buttons
	button_edit_abilities_edit = sim:addButton( 8002, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Edit" )
	button_edit_abilities_edit:setParent( window_edit_abilities_list )		
	button_edit_abilities_edit:setImage( button_small_texture )
	button_edit_abilities_edit:setPressedImage( button_small_pressed_texture )	
	
	x = x+ btn_w + 6
	button_edit_abilities_delete = sim:addButton( 8003, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Delete" )
	button_edit_abilities_delete:setParent( window_edit_abilities_list )		
	button_edit_abilities_delete:setImage( button_small_texture )
	button_edit_abilities_delete:setPressedImage( button_small_pressed_texture )	

	x = 0
	y = y + 30
	btn_w = 128
	button_edit_abilities_add = sim:addButton( 8001, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Add" )
	button_edit_abilities_add:setParent( window_edit_abilities_list )	
	button_edit_abilities_add:setImage( button_texture )
	button_edit_abilities_add:setPressedImage( button_pressed_texture )	
	
	
	sim:bindGUI ( "button_edit_abilities_add_pressed", 8001, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "button_edit_abilities_edit_pressed", 8002, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "button_edit_abilities_delete_pressed", 8003, xcore.XGUI_BUTTON_CLICKED )

	--
	-- data window
	--
	x = 260
	y = 60
	window_edit_abilities_data = sim:addWindow( 1000, xcore.x2drect(x, y, x+380, y+400), "Ability Data")	
	
	y = 30
	x = 20	
	-- add text input for name
	label_edit_abilities_name = sim:addText( 0, "Name", x, y, x+100, y+20 )
	label_edit_abilities_name:setParent( window_edit_abilities_data )
	x = x+110
	textfield_edit_abilities_name = sim:addEditbox( 20,  xcore.x2drect( x,y,x+200,y+20 ) )
	textfield_edit_abilities_name:setParent( window_edit_abilities_data )	

	y = y + 30
	x = 20		
	-- add text input for level
	label_edit_abilities_level = sim:addText( 0, "Level", x, y, x+50, y+20 )
	label_edit_abilities_level:setParent( window_edit_abilities_data )
	x = x+110
	textfield_edit_abilities_level = sim:addEditbox( 20,  xcore.x2drect( x,y,x+40,y+20 ) )
	textfield_edit_abilities_level:setParent( window_edit_abilities_data )	
	x = x + 50
	-- add numeric inputs for type
	label_edit_abilities_type = sim:addText( 0, "Type", x, y, x+50, y+20 )
	label_edit_abilities_type:setParent( window_edit_abilities_data )
	x = x+110
	textfield_edit_abilities_type = sim:addEditbox( 20,  xcore.x2drect( x,y,x+40,y+20 ) )
	textfield_edit_abilities_type:setParent( window_edit_abilities_data )		
	
		y = y + 30
	x = 20
	-- add numeric inputs for type
	label_edit_abilities_effect = sim:addText( 0, "Effect", x, y, x+50, y+20 )
	label_edit_abilities_effect:setParent( window_edit_abilities_data )
	x = x+110
	textfield_edit_abilities_effect = sim:addEditbox( 20,  xcore.x2drect( x,y,x+40,y+20 ) )
	textfield_edit_abilities_effect:setParent( window_edit_abilities_data )	
	x = x + 50
	-- add numeric inputs for type
	label_edit_abilities_radius = sim:addText( 0, "Radius", x, y, x+50, y+20 )
	label_edit_abilities_radius:setParent( window_edit_abilities_data )
	x = x+110
	textfield_edit_abilities_radius = sim:addEditbox( 20,  xcore.x2drect( x,y,x+40,y+20 ) )
	textfield_edit_abilities_radius:setParent( window_edit_abilities_data )	


	y = y + 30
	x = 20
	-- add numeric inputs for type
	label_edit_abilities_graphic = sim:addText( 0, "Graphic", x, y, x+100, y+20 )
	label_edit_abilities_graphic:setParent( window_edit_abilities_data )
	x = x+110
	textfield_edit_abilities_graphic = sim:addEditbox( 20,  xcore.x2drect( x,y,x+200,y+20 ) )
	textfield_edit_abilities_graphic:setParent( window_edit_abilities_data )	

	
	y = y + 30
	x = 20		
	-- add inputs for class
	label_edit_abilities_class = sim:addText( 0, "Class", x, y, x+100, y+20 ) -- dropdown w/ ENUM_OBJ_CLASS or whatever?
	label_edit_abilities_class:setParent( window_edit_abilities_data )
	x = x+110
	textfield_edit_abilities_class = sim:addEditbox( 20,  xcore.x2drect( x,y,x+200,y+20 ) )
	textfield_edit_abilities_class:setParent( window_edit_abilities_data )	
	
	--[[
	combobox_edit_abilities_class = sim:addCombobox( 11, xcore.x2drect(x, y, x+130, y+20 ) )
	combobox_edit_abilities_class:setParent( window_edit_abilities_data )
	combobox_edit_abilities_class:addItem("Test Class")
	]]--

	y = y + 30
	x = 20		
	-- add seperator
	label_edit_abilities_sep = sim:addText( 0, "Stats ", x, y, x+150, y+20 )
	label_edit_abilities_sep:setParent( window_edit_abilities_data )

	y = y + 30
	x = 20		
	-- add numeric inputs for att and def
	label_edit_abilities_atk = sim:addText( 0, "Atk", x, y, x+50, y+20 )
	label_edit_abilities_atk:setParent( window_edit_abilities_data )
	x = x+110
	textfield_edit_abilities_atk = sim:addEditbox( 20,  xcore.x2drect( x,y,x+40,y+20 ) )
	textfield_edit_abilities_atk:setParent( window_edit_abilities_data )	
	x = x + 50
	label_edit_abilities_def = sim:addText( 0, "Def", x, y, x+50, y+20 )
	label_edit_abilities_def:setParent( window_edit_abilities_data )
	x = x+110
	textfield_edit_abilities_def = sim:addEditbox( 20,  xcore.x2drect( x,y,x+40,y+20 ) )
	textfield_edit_abilities_def:setParent( window_edit_abilities_data )		

	y = y + 30
	x = 20		
	-- add numeric inputs for att and def
	label_edit_abilities_mov = sim:addText( 0, "Mov", x, y, x+50, y+20 )
	label_edit_abilities_mov:setParent( window_edit_abilities_data )
	x = x+110
	textfield_edit_abilities_mov = sim:addEditbox( 20,  xcore.x2drect( x,y,x+40,y+20 ) )
	textfield_edit_abilities_mov:setParent( window_edit_abilities_data )	
	x = x + 50
	label_edit_abilities_rng = sim:addText( 0, "Rng", x, y, x+50, y+20 )
	label_edit_abilities_rng:setParent( window_edit_abilities_data )
	x = x+110
	textfield_edit_abilities_rng = sim:addEditbox( 20,  xcore.x2drect( x,y,x+40,y+20 ) )
	textfield_edit_abilities_rng:setParent( window_edit_abilities_data )		

	y = y + 30
	x = 20		
	-- add numeric inputs for att and def
	label_edit_abilities_hp = sim:addText( 0, "HP", x, y, x+50, y+20 )
	label_edit_abilities_hp:setParent( window_edit_abilities_data )
	x = x+110
	textfield_edit_abilities_hp = sim:addEditbox( 20,  xcore.x2drect( x,y,x+40,y+20 ) )
	textfield_edit_abilities_hp:setParent( window_edit_abilities_data )	
	x = x + 50
	label_edit_abilities_sp = sim:addText( 0, "SP", x, y, x+50, y+20 )
	label_edit_abilities_sp:setParent( window_edit_abilities_data )
	x = x+110
	textfield_edit_abilities_sp = sim:addEditbox( 20,  xcore.x2drect( x,y,x+40,y+20 ) )
	textfield_edit_abilities_sp:setParent( window_edit_abilities_data )		

	y = y + 30
	x = 20		
	-- add numeric inputs for att and def
	label_edit_abilities_dam = sim:addText( 0, "Dam", x, y, x+50, y+20 )
	label_edit_abilities_dam:setParent( window_edit_abilities_data )
	x = x+110
	textfield_edit_abilities_dam = sim:addEditbox( 20,  xcore.x2drect( x,y,x+40,y+20 ) )
	textfield_edit_abilities_dam:setParent( window_edit_abilities_data )	
	x = x + 50
	label_edit_abilities_drn = sim:addText( 0, "Drn", x, y, x+50, y+20 )
	label_edit_abilities_drn:setParent( window_edit_abilities_data )
	x = x+110
	textfield_edit_abilities_drn = sim:addEditbox( 20,  xcore.x2drect( x,y,x+40,y+20 ) )
	textfield_edit_abilities_drn:setParent( window_edit_abilities_data )		

	y = y + 50
	btn_w = 160
	x = 120
	button_edit_abilities_save = sim:addButton( 8011, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Save" )
	button_edit_abilities_save:setParent( window_edit_abilities_data )		
	button_edit_abilities_save:setImage( button_texture )
	button_edit_abilities_save:setPressedImage( button_pressed_texture )

	sim:bindGUI ( "button_edit_abilities_save_pressed", 8011, xcore.XGUI_BUTTON_CLICKED )

	stat_id = -1
	self.mode = 1
	self.current_ability_id = -1

	self:hide()
	return o
end

function edit_abilities:hide()
	-- print "[edit_abilities] hide"
	window_edit_abilities_list:setVisible( false )
	window_edit_abilities_data:setVisible( false )
end

function edit_abilities:show()
	-- print "[edit_abilities] show"
	self:updateList()

	window_edit_abilities_list:setVisible( true )
	-- print "[edit_abilities] /show"
end

function edit_abilities:destroy()
	-- print "[edit_abilities] destroy"
	window_edit_abilities_list:destroy()
end

function edit_abilities:input()
	if sim:isGUI( "button_edit_abilities_add_pressed" ) then
		window_edit_abilities_data:setVisible( true )
		self:showAdd()
	end
	if sim:isGUI( "button_edit_abilities_edit_pressed" ) then
		window_edit_abilities_data:setVisible( true )
		self:showEdit()
	end
	if sim:isGUI( "button_edit_abilities_delete_pressed" ) then
		self:delete()
	end	
	if sim:isGUI( "button_edit_abilities_save_pressed" ) then
		self:save()
	end	
end

function edit_abilities:listClasses()
	-- list classes
	combobox_edit_member_class:clear()
	statement = "SELECT class_name FROM table_classes WHERE class_type > 0 "
	local q = sql:exe( statement )
	if q ~= nil then
		for i = 0, q:getRowCount()-1 do
			local n = i*q:getHeadCount()
				combobox_edit_abilities_class:addItem( q:getData( i ) )
		end
	end
	sql:removeResult( q )
end

function edit_abilities:save()
	-- print("[edit_abilities] save")
	-- item_name, item_type, item_class, item_effect, item_graphic, item_stat, stat_attack, stat_defense, stat_speed, stat_range, stat_damage, stat_drain, stat_sp, stat_hp

	if self.mode == 1 then
		-- print("[edit_abilities] insert row")
		query = " INSERT INTO table_stats "
		query = query .. " ( stat_attack, stat_defense, stat_speed, stat_range, stat_damage, stat_drain, stat_sp, stat_hp )"
		query = query .. "VALUES ( "
		query = query .. textfield_edit_abilities_atk:getText() .. ", "
		query = query .. textfield_edit_abilities_def:getText() .. ", "
		query = query .. textfield_edit_abilities_mov:getText() .. ", "
		query = query .. textfield_edit_abilities_rng:getText() .. ", "
		query = query .. textfield_edit_abilities_dam:getText() .. ", "
		query = query .. textfield_edit_abilities_drn:getText() .. ", "
		query = query .. textfield_edit_abilities_sp:getText() .. ", "
		query = query .. textfield_edit_abilities_hp:getText() .. " "
		query = query .. " ); SELECT last_insert_rowid()"
		-- print ( query )
		q = sql:exe( query )
		-- print("last_insert_rowid: " .. q:getData( 0 ) )

		stat_id = q:getData( 0 )
		sql:removeResult( q )

		query = " INSERT INTO table_specials "
		query = query .. " ( special_name, special_level, special_class, special_effect, special_radius, special_type, special_graphic, special_stats )"
		query = query .. "VALUES ( "
		query = query .. "'".. textfield_edit_abilities_name:getText() .. "', "
		query = query .. "'".. textfield_edit_abilities_level:getText() .. "', "
		query = query .. "'".. textfield_edit_abilities_class:getText() .. "', "
		query = query .. "'".. textfield_edit_abilities_effect:getText() .. "', "
		query = query .. "'".. textfield_edit_abilities_radius:getText() .. "', "
		query = query .. "'".. textfield_edit_abilities_type:getText() .. "', "
		query = query .. "'".. textfield_edit_abilities_graphic:getText() .. "', "
		query = query .. stat_id .. " "
		query = query .. " )"

		-- print( query )
		sql:exe( query )
	else
		-- print("[edit_abilities] update row")
		query = "UPDATE table_stats SET "
		query = query .. " stat_attack = '" .. textfield_edit_abilities_atk:getText() .. "', "
		query = query .. " stat_defense = '" .. textfield_edit_abilities_def:getText() .. "', "
		query = query .. " stat_speed = " .. textfield_edit_abilities_mov:getText() .. ", "
		query = query .. " stat_range = " .. textfield_edit_abilities_rng:getText() .. ", "
		query = query .. " stat_damage = " .. textfield_edit_abilities_dam:getText() .. ", "
		query = query .. " stat_drain = " .. textfield_edit_abilities_drn:getText() .. ", "
		query = query .. " stat_sp = " .. textfield_edit_abilities_sp:getText() .. ", "
		query = query .. " stat_hp = " .. textfield_edit_abilities_hp:getText() .. " "
		query = query .. " WHERE stat_id = " .. stat_id
		
		-- print ( query )
		q = sql:exe( query )
		query = "UPDATE table_specials SET "
		query = query .. " special_name = '" .. textfield_edit_abilities_name:getText() .. "', "
		query = query .. " special_level = '" .. textfield_edit_abilities_level:getText() .. "', "
		query = query .. " special_class = '" .. textfield_edit_abilities_class:getText() .. "', "
		query = query .. " special_effect = '" .. textfield_edit_abilities_effect:getText() .. "', "
		query = query .. " special_radius = '" .. textfield_edit_abilities_radius:getText() .. "', "
		query = query .. " special_type = '" .. textfield_edit_abilities_type:getText() .. "', "
		query = query .. " special_graphic = '" .. textfield_edit_abilities_graphic:getText() .. "', "		
		query = query .. " special_stats = " .. stat_id

		query = query .. " WHERE special_id = " .. self.current_ability_id
		-- print( query )
		sql:exe( query )
	end
	self:updateList()
end

function edit_abilities:delete()
	if listbox_edit_abilities:getSelected() == -1 then return nil end
	n = listbox_edit_abilities:getItem( listbox_edit_abilities:getSelected() )
	-- print("[edit_abilities] delete special : " .. n)
	
	query = "DELETE FROM table_specials WHERE special_name = '" ..  n .. "'"
	local q = sql:exe( query )
	if stat_id > 0 then 
		-- print("[edit_abilities] delete statline : " .. stat_id)
		query = "DELETE FROM table_stats WHERE stat_id = '" ..  stat_id .. "'"
		local q = sql:exe( query )
	end
	
	self:updateList()
end

function edit_abilities:showAdd()
	self.mode = 1
	-- print "[edit_abilities] showAdd"
	-- show confirmation
	textfield_edit_abilities_name:setText("")
	textfield_edit_abilities_level:setText( "0" )
	textfield_edit_abilities_class:setText( "0" )
	textfield_edit_abilities_type:setText( "0" )	
	textfield_edit_abilities_graphic:setText( "" )
	textfield_edit_abilities_effect:setText( "0" )
	textfield_edit_abilities_atk:setText( "0" )
	textfield_edit_abilities_def:setText( "0" )
	textfield_edit_abilities_mov:setText( "0" )
	textfield_edit_abilities_rng:setText( "0" )
	textfield_edit_abilities_dam:setText( "0" )
	textfield_edit_abilities_drn:setText( "0" )
	textfield_edit_abilities_sp:setText( "0" )
	textfield_edit_abilities_hp:setText( "0" )
	stat_id = -1
end

function edit_abilities:showEdit()
	self.mode = 2
	-- print "[edit_abilities] showEdit"
	-- show confirmation

	n = listbox_edit_abilities:getItem( listbox_edit_abilities:getSelected() )
	-- print("[edit_abilities] edit ability : " .. n)
	query = "SELECT special_name, special_level, special_class, special_effect, special_stats, stat_attack, stat_defense, stat_speed, stat_range, stat_damage, stat_drain, stat_sp, stat_hp, special_id, special_radius, special_type, special_graphic FROM table_specials LEFT JOIN table_stats on stat_id = special_stats WHERE special_name = '" ..  n .. "'"
	local q = sql:exe( query )
	if q ~= nil then
		if q:getData( 0 ) ~= nil then
			-- print ("[edit_abilities] name : " .. q:getData( 0 ) )
			textfield_edit_abilities_name:setText( q:getData( 0 ) )
		end
		if q:getData( 1 ) ~= nil then
			-- print ( q:getData( 1 ) )
			textfield_edit_abilities_level:setText( q:getData( 1 ) )
		end
		if q:getData( 2 ) ~= nil then
			-- print ( q:getData( 2 ) )
			textfield_edit_abilities_class:setText( q:getData( 2 ) )
		end
		if q:getData( 3 ) ~= nil then
			textfield_edit_abilities_effect:setText( q:getData( 3 ) )
		end
		if q:getData( 4 ) ~= nil then -- item_effect
			stat_id = tonumber( q:getData( 4 ) )
		else
			stat_id = -1
		end
		if q:getData( 5 ) ~= nil then
			textfield_edit_abilities_atk:setText( q:getData( 5 ) )
		end
		if q:getData( 6 ) ~= nil then
			textfield_edit_abilities_def:setText( q:getData( 6 ) )
		end
		if q:getData( 7 ) ~= nil then
			textfield_edit_abilities_mov:setText( q:getData( 7 ) )
		end
		if q:getData( 8 ) ~= nil then
			textfield_edit_abilities_rng:setText( q:getData( 8 ) )
		end
		if q:getData( 9 ) ~= nil then
			textfield_edit_abilities_dam:setText( q:getData( 9 ) )
		end
		if q:getData( 10 ) ~= nil then
			textfield_edit_abilities_drn:setText( q:getData( 10 ) )
		end
		if q:getData( 11 ) ~= nil then
			textfield_edit_abilities_sp:setText( q:getData( 11 ) )
		end
		if q:getData( 12 ) ~= nil then
			textfield_edit_abilities_hp:setText( q:getData( 12 ) )
		end
		
		self.current_ability_id = tonumber( q:getData( 13 ) )

		if q:getData( 14 ) ~= nil then
			-- print ( q:getData( 2 ) )
			textfield_edit_abilities_radius:setText( q:getData( 14 ) )
		end
		
		if q:getData( 15 ) ~= nil then
			-- print ( q:getData( 2 ) )
			textfield_edit_abilities_type:setText( q:getData( 15 ) )
		end

		if q:getData( 16 ) ~= nil then
			-- print ( q:getData( 2 ) )
			textfield_edit_abilities_graphic:setText( q:getData( 16 ) )
		end
	--[[
		textfield_edit_abilities_atk
		textfield_edit_abilities_def
		textfield_edit_abilities_mov
		textfield_edit_abilities_rng
		textfield_edit_abilities_hp
		textfield_edit_abilities_sp
		textfield_edit_abilities_dam
		textfield_edit_abilities_drn
	]]--
	end
end

function edit_abilities:showDelete()
	-- print "[edit_abilities] showDelete"
	-- show confirmation
end

function edit_abilities:updateList()
	-- print "[edit_abilities] updateList"
	listbox_edit_abilities:clear()
	statement = "SELECT special_name FROM table_specials WHERE 0 = 0 ORDER BY special_class ASC, special_level ASC"
	local q = sql:exe( statement )
	if q ~= nil then
		for i = 0, q:getRowCount()-1 do
			local n = i*q:getHeadCount()
				listbox_edit_abilities:addItem( q:getData( i ) )
		end
	end
	sql:removeResult( q )
	window_edit_abilities_data:setVisible( false )
end

-- end of file