-- Dungeon Tactics
-- Copyright 2012 lukas w. irwin [ lukas.w.irwin@gmail.com ]
-- This program is free software under the terms of the GNU General Public License version 3 or later.
-- edit_effects.lua

edit_effects = { ID = 0 }

-- print "[edit_effects]"

-- creation
function edit_effects:new (o)
	-- print "[edit_effects] new edit_effects"
	o = o or {}
	setmetatable(o, self)
	self.__index = self

	btn_w = 60
	btn_h = 30

	--
	-- list window
	--
	x = 10
	y = 60
	window_edit_effects_list = sim:addWindow( 1000, xcore.x2drect(x, y, x+128, y+256+60), "Effect List")
	window_edit_effects_list:setTitleBarVisible( false )		
	image_background_edit_list = sim:addImage( 0, texture_background_128x256, xcore.x2dpoint(0, 0),
		xcore.x2drect(0,0,64,64), xcore.xcolour(255,255,255,255) )
	image_background_edit_list:setParent( window_edit_effects_list )
	
	-- list
	width = 118	
	x = 5
	y = 10
	height = 236
	listbox_edit_effects = sim:addListbox( 1010, true, xcore.x2drect( x,y,x+width,y+height ) )
	listbox_edit_effects:setParent( window_edit_effects_list )
	listbox_edit_effects:addItem("test")

	x = 0
	y = 256

	button_edit_effects_edit = sim:addButton( 5702, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Edit" )
	button_edit_effects_edit:setParent( window_edit_effects_list )		
	button_edit_effects_edit:setImage( button_small_texture )
	button_edit_effects_edit:setPressedImage( button_small_pressed_texture )	

	x = x+ btn_w + 6
	button_edit_effects_delete = sim:addButton( 5703, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Delete" )
	button_edit_effects_delete:setParent( window_edit_effects_list )		
	button_edit_effects_delete:setImage( button_small_texture )
	button_edit_effects_delete:setPressedImage( button_small_pressed_texture )	

	x = 0
	y = y + 30
	btn_w = 128
	-- add some buttons
	button_edit_effects_add = sim:addButton( 5701, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Add" )
	button_edit_effects_add:setParent( window_edit_effects_list )	
	button_edit_effects_add:setImage( button_texture )
	button_edit_effects_add:setPressedImage( button_pressed_texture )	

	
	sim:bindGUI ( "button_edit_effects_add_pressed", 5701, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "button_edit_effects_edit_pressed", 5702, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "button_edit_effects_delete_pressed", 5703, xcore.XGUI_BUTTON_CLICKED )
	
	--
	-- data window
	--
	x = 260
	y = 60
	window_edit_effects_data = sim:addWindow( 1000, xcore.x2drect(x, y, x+380, y+500), "Effect Data")	
	
	y = 30
	x = 20	
	-- add text input for name
	label_edit_effects_name = sim:addText( 0, "Name", x, y, x+100, y+20 )
	label_edit_effects_name:setParent( window_edit_effects_data )
	x = x+110
	textfield_edit_effects_name = sim:addEditbox( 20,  xcore.x2drect( x,y,x+200,y+20 ) )
	textfield_edit_effects_name:setParent( window_edit_effects_data )	

	y = y + 30
	x = 20		
	-- add text input for Graphic
	label_edit_effects_icon = sim:addText( 0, "Icon", x, y, x+100, y+20 )
	label_edit_effects_icon:setParent( window_edit_effects_data )
	x = x+110
	textfield_edit_effects_icon = sim:addEditbox( 20,  xcore.x2drect( x,y,x+200,y+20 ) )
	textfield_edit_effects_icon:setParent( window_edit_effects_data )	

	y = y + 30
	x = 20		
	-- add numeric inputs for class
	label_edit_effects_animation = sim:addText( 0, "Animation", x, y, x+100, y+20 )
	label_edit_effects_animation:setParent( window_edit_effects_data )
	x = x+110
	textfield_edit_effects_animation = sim:addEditbox( 20,  xcore.x2drect( x,y,x+200,y+20 ) )
	textfield_edit_effects_animation:setParent( window_edit_effects_data )	

	y = y + 30
	x = 20		
	-- add numeric inputs for type
	label_edit_effects_type = sim:addText( 0, "Type", x, y, x+100, y+20 )
	label_edit_effects_type:setParent( window_edit_effects_data )
	x = x+110
	combobox_edit_effects_type = sim:addCombobox( 100, xcore.x2drect(x, y, x+150, y+20 ) )
	combobox_edit_effects_type:setParent( window_edit_effects_data )
	combobox_edit_effects_type:addItem("CLEAR")
	combobox_edit_effects_type:addItem("NO_ACT")
	combobox_edit_effects_type:addItem("NO_MOVE")	
	combobox_edit_effects_type:addItem("NO_SPECIAL")
	combobox_edit_effects_type:addItem("NO_ATTACK")
	combobox_edit_effects_type:addItem("DAMAGE")
	combobox_edit_effects_type:addItem("BUFF")
	combobox_edit_effects_type:addItem("DEBUFF")
	combobox_edit_effects_type:addItem("SUMMON")
	-- combobox_edit_effects_type:addItem("TRAP")
	-- combobox_edit_effects_type:addItem("STEAL")
	
	y = y + 30
	x = 20		
	-- add numeric inputs for tier
	label_edit_effects_stack = sim:addText( 0, "Stack", x, y, x+100, y+20 )
	label_edit_effects_stack:setParent( window_edit_effects_data )
	x = x+110
	textfield_edit_effects_stack = sim:addEditbox( 20,  xcore.x2drect( x,y,x+200,y+20 ) )
	textfield_edit_effects_stack:setParent( window_edit_effects_data )	
	
	y = y + 30
	x = 20		
	-- add numeric inputs for desc
	label_edit_effects_break = sim:addText( 0, "Break", x, y, x+100, y+20 )
	label_edit_effects_break:setParent( window_edit_effects_data )
	x = x+110
	textfield_edit_effects_break = sim:addEditbox( 20,  xcore.x2drect( x,y,x+200,y+20 ) )
	textfield_edit_effects_break:setParent( window_edit_effects_data )	

	y = y + 30
	x = 20		
	-- add numeric inputs for duration
	label_edit_effects_duration = sim:addText( 0, "Duration", x, y, x+100, y+20 )
	label_edit_effects_duration:setParent( window_edit_effects_data )
	x = x+110
	textfield_edit_effects_duration = sim:addEditbox( 20,  xcore.x2drect( x,y,x+200,y+20 ) )
	textfield_edit_effects_duration:setParent( window_edit_effects_data )	

	y = y + 30
	x = 20		
	-- add numeric inputs for class
	label_edit_effects_magnitude = sim:addText( 0, "Magnitude", x, y, x+100, y+20 )
	label_edit_effects_magnitude:setParent( window_edit_effects_data )
	x = x+110
	textfield_edit_effects_magnitude = sim:addEditbox( 20,  xcore.x2drect( x,y,x+200,y+20 ) )
	textfield_edit_effects_magnitude:setParent( window_edit_effects_data )	

	y = y + 30
	x = 20		
	-- add seperator
	label_edit_effects_sep = sim:addText( 0, "Stats ", x, y, x+150, y+20 )
	label_edit_effects_sep:setParent( window_edit_effects_data )

	y = y + 30
	x = 20		
	-- add numeric inputs for att and def
	label_edit_effects_atk = sim:addText( 0, "Atk", x, y, x+50, y+20 )
	label_edit_effects_atk:setParent( window_edit_effects_data )
	x = x+110
	textfield_edit_effects_atk = sim:addEditbox( 20,  xcore.x2drect( x,y,x+40,y+20 ) )
	textfield_edit_effects_atk:setParent( window_edit_effects_data )	
	x = x + 50
	label_edit_effects_def = sim:addText( 0, "Def", x, y, x+50, y+20 )
	label_edit_effects_def:setParent( window_edit_effects_data )
	x = x+110
	textfield_edit_effects_def = sim:addEditbox( 20,  xcore.x2drect( x,y,x+40,y+20 ) )
	textfield_edit_effects_def:setParent( window_edit_effects_data )		

	y = y + 30
	x = 20		
	-- add numeric inputs for att and def
	label_edit_effects_mov = sim:addText( 0, "Mov", x, y, x+50, y+20 )
	label_edit_effects_mov:setParent( window_edit_effects_data )
	x = x+110
	textfield_edit_effects_mov = sim:addEditbox( 20,  xcore.x2drect( x,y,x+40,y+20 ) )
	textfield_edit_effects_mov:setParent( window_edit_effects_data )	
	x = x + 50
	label_edit_effects_rng = sim:addText( 0, "Rng", x, y, x+50, y+20 )
	label_edit_effects_rng:setParent( window_edit_effects_data )
	x = x+110
	textfield_edit_effects_rng = sim:addEditbox( 20,  xcore.x2drect( x,y,x+40,y+20 ) )
	textfield_edit_effects_rng:setParent( window_edit_effects_data )		

	y = y + 30
	x = 20		
	-- add numeric inputs for att and def
	label_edit_effects_hp = sim:addText( 0, "HP", x, y, x+50, y+20 )
	label_edit_effects_hp:setParent( window_edit_effects_data )
	x = x+110
	textfield_edit_effects_hp = sim:addEditbox( 20,  xcore.x2drect( x,y,x+40,y+20 ) )
	textfield_edit_effects_hp:setParent( window_edit_effects_data )	
	x = x + 50
	label_edit_effects_sp = sim:addText( 0, "SP", x, y, x+50, y+20 )
	label_edit_effects_sp:setParent( window_edit_effects_data )
	x = x+110
	textfield_edit_effects_sp = sim:addEditbox( 20,  xcore.x2drect( x,y,x+40,y+20 ) )
	textfield_edit_effects_sp:setParent( window_edit_effects_data )		

	y = y + 30
	x = 20		
	-- add numeric inputs for att and def
	label_edit_effects_dam = sim:addText( 0, "Dam", x, y, x+50, y+20 )
	label_edit_effects_dam:setParent( window_edit_effects_data )
	x = x+110
	textfield_edit_effects_dam = sim:addEditbox( 20,  xcore.x2drect( x,y,x+40,y+20 ) )
	textfield_edit_effects_dam:setParent( window_edit_effects_data )	
	x = x + 50
	label_edit_effects_drn = sim:addText( 0, "Drn", x, y, x+50, y+20 )
	label_edit_effects_drn:setParent( window_edit_effects_data )
	x = x+110
	textfield_edit_effects_drn = sim:addEditbox( 20,  xcore.x2drect( x,y,x+40,y+20 ) )
	textfield_edit_effects_drn:setParent( window_edit_effects_data )		

	y = y + 50
	btn_w = 160
	x = 120
	button_edit_effects_save = sim:addButton( 5711, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Save" )
	button_edit_effects_save:setParent( window_edit_effects_data )		
	button_edit_effects_save:setImage( button_texture )
	button_edit_effects_save:setPressedImage( button_pressed_texture )

	sim:bindGUI ( "button_edit_effects_save_pressed", 5711, xcore.XGUI_BUTTON_CLICKED )

	stat_id = -1
	self.mode = 1
	self.current_class_id = -1

	self:hide()
	return o
end

function edit_effects:hide()
	-- print "[edit_effects] hide"
	window_edit_effects_list:setVisible( false )
	window_edit_effects_data:setVisible( false )
end

function edit_effects:show()
	-- print "[edit_effects] show"
	self:updateList()

	window_edit_effects_list:setVisible( true )
	-- print "[edit_effects] /show"
end

function edit_effects:destroy()
	-- print "[edit_effects] destroy"
	window_edit_effects_list:destroy()
end

function edit_effects:input()
	if sim:isGUI( "button_edit_effects_add_pressed" ) then
		window_edit_effects_data:setVisible( true )
		self:showAdd()
	end
	if sim:isGUI( "button_edit_effects_edit_pressed" ) then
		window_edit_effects_data:setVisible( true )
		self:showEdit()
	end
	if sim:isGUI( "button_edit_effects_delete_pressed" ) then
		self:delete()
	end	
	if sim:isGUI( "button_edit_effects_save_pressed" ) then
		self:save()
	end	
end

function edit_effects:save()
	-- print("[edit_effects] save")
	
	--[[
	effect_name
	effect_type
	effect_duration
	effect_magnitude
	effect_break
	effect_stack
	effect_icon
	effect_animation
	--]]
	
	if self.mode == 1 then
		-- print("[edit_effects] insert row")
		query = " INSERT INTO table_stats "
		query = query .. " ( stat_attack, stat_defense, stat_speed, stat_range, stat_damage, stat_drain, stat_sp, stat_hp )"
		query = query .. "VALUES ( "
		query = query .. "'" .. textfield_edit_effects_atk:getText() .. "', "
		query = query .. "'" .. textfield_edit_effects_def:getText() .. "', "
		query = query .. "'" .. textfield_edit_effects_mov:getText() .. "', "
		query = query .. "'" .. textfield_edit_effects_rng:getText() .. "', "
		query = query .. "'" .. textfield_edit_effects_dam:getText() .. "', "
		query = query .. "'" .. textfield_edit_effects_drn:getText() .. "', "
		query = query .. "'" .. textfield_edit_effects_sp:getText() .. "', "
		query = query .. "'" .. textfield_edit_effects_hp:getText() .. "' "
		query = query .. " ); SELECT last_insert_rowid()"
		-- print ( query )
		q = sql:exe( query )
		-- print("last_insert_rowid: " .. q:getData( 0 ) )

		stat_id = q:getData( 0 )
		sql:removeResult( q )

		query = " INSERT INTO table_effects "
		query = query .. " ( effect_name, effect_type, effect_duration, effect_magnitude, effect_break, effect_stack, effect_icon, effect_animation, effect_stats )"
		query = query .. "VALUES ( "
		query = query .. "'".. textfield_edit_effects_name:getText() .. "', "
		query = query .. "'".. combobox_edit_effects_type:getSelected() .. "', "
		query = query .. "'".. textfield_edit_effects_duration:getText() .. "', "
		query = query .. "'".. textfield_edit_effects_magnitude:getText() .. "', "
		query = query .. "'".. textfield_edit_effects_break:getText() .. "', "
		query = query .. "'".. textfield_edit_effects_stack:getText() .. "', "
		query = query .. "'".. textfield_edit_effects_icon:getText() .. "', "
		query = query .. "'".. textfield_edit_effects_animation:getText() .. "', "		
		query = query .. stat_id .. "  "

		query = query .. " )"
		-- print( query )
		sql:exe( query )
	else
		-- print("[edit_effects] update row")
		query = "UPDATE table_stats SET "
		query = query .. " stat_attack = '" .. textfield_edit_effects_atk:getText() .. "', "
		query = query .. " stat_defense = '" .. textfield_edit_effects_def:getText() .. "', "
		query = query .. " stat_speed = '" .. textfield_edit_effects_mov:getText() .. "', "
		query = query .. " stat_range = '" .. textfield_edit_effects_rng:getText() .. "', "
		query = query .. " stat_damage = '" .. textfield_edit_effects_dam:getText() .. "', "
		query = query .. " stat_drain = '" .. textfield_edit_effects_drn:getText() .. "', "
		query = query .. " stat_sp = '" .. textfield_edit_effects_sp:getText() .. "', "
		query = query .. " stat_hp = '" .. textfield_edit_effects_hp:getText() .. "' "
		query = query .. " WHERE stat_id = " .. stat_id
		
		-- print ( query )
		q = sql:exe( query )
		
		query = "UPDATE table_effects SET "
		query = query .. " effect_name = '" .. textfield_edit_effects_name:getText() .. "', "
		query = query .. " effect_type = '" .. combobox_edit_effects_type:getSelected() .. "', "
		query = query .. " effect_duration = '" .. textfield_edit_effects_duration:getText() .. "', "
		query = query .. " effect_magnitude = '" .. textfield_edit_effects_magnitude:getText() .. "', "
		query = query .. " effect_break = '" .. textfield_edit_effects_break:getText() .. "', "
		query = query .. " effect_stack = '".. textfield_edit_effects_stack:getText() .. "', "
		query = query .. " effect_icon = '".. textfield_edit_effects_icon:getText() .. "', "		
		query = query .. " effect_animation = '".. textfield_edit_effects_animation:getText() .. "', "		
		query = query .. " effect_stats = " .. stat_id

		query = query .. " WHERE effect_id = " .. self.current_effect_id
		-- print( query )
		sql:exe( query )
	end
	self:updateList()
end

function edit_effects:delete()
	if listbox_edit_effects:getSelected() == -1 then return nil end
	n = listbox_edit_effects:getItem( listbox_edit_effects:getSelected() )
	-- print("[edit_effects] delete class : " .. n)
	
	query = "DELETE FROM table_effects WHERE effect_name = '" ..  n .. "'"
	local q = sql:exe( query )
	if stat_id > 0 then 
		-- print("[edit_effects] delete statline : " .. stat_id)
		query = "DELETE FROM table_stats WHERE stat_id = '" ..  stat_id .. "'"
		local q = sql:exe( query )
	end
	
	self:updateList()
end

function edit_effects:showAdd()
	self.mode = 1
	-- print "[edit_effects] showAdd"
	-- show confirmation

	textfield_edit_effects_name:setText("")
	combobox_edit_effects_type:setSelected( 0 )
	textfield_edit_effects_duration:setText( "0" )
	textfield_edit_effects_magnitude:setText( "0" )
	textfield_edit_effects_break:setText( "0" )
	textfield_edit_effects_stack:setText( "0" )
	textfield_edit_effects_icon:setText( "" )
	textfield_edit_effects_animation:setText( "" )	

	textfield_edit_effects_atk:setText( "0" )
	textfield_edit_effects_def:setText( "0" )
	textfield_edit_effects_mov:setText( "0" )
	textfield_edit_effects_rng:setText( "0" )
	textfield_edit_effects_dam:setText( "0" )
	textfield_edit_effects_drn:setText( "0" )
	textfield_edit_effects_sp:setText( "0" )
	textfield_edit_effects_hp:setText( "0" )

	stat_id = -1
end

function edit_effects:showEdit()
	self.mode = 2
	-- print "[edit_effects] showEdit"
	-- show confirmation

	n = listbox_edit_effects:getItem( listbox_edit_effects:getSelected() )
	-- print("[edit_effects] edit item : " .. n)
	query = "SELECT effect_name, effect_type, effect_duration, effect_magnitude, effect_break, effect_stack, effect_icon, effect_animation, effect_stats, stat_attack, stat_defense, stat_speed, stat_range, stat_damage, stat_drain, stat_sp, stat_hp, effect_id FROM table_effects LEFT JOIN table_stats on stat_id = effect_stats WHERE effect_name = '" ..  n .. "'"
	local q = sql:exe( query )
	if q ~= nil then
		if q:getData( 0 ) ~= nil then
			-- print ("[edit_effects] name : " .. q:getData( 0 ) )
			textfield_edit_effects_name:setText( q:getData( 0 ) )
		end
		if q:getData( 1 ) ~= nil then
			-- print ( q:getData( 1 ) )
			combobox_edit_effects_type:setSelected( q:getData( 1 ) )
		end
		if q:getData( 2 ) ~= nil then
			-- print ( q:getData( 2 ) )
			textfield_edit_effects_duration:setText( q:getData( 2 ) )
		end
		if q:getData( 3 ) ~= nil then
			textfield_edit_effects_magnitude:setText( q:getData( 3 ) )
		end
		if q:getData( 4 ) ~= nil then -- item_effect
			textfield_edit_effects_break:setText( q:getData( 4 ) )
		end
		if q:getData( 5 ) ~= nil then -- item_effect
			textfield_edit_effects_stack:setText( q:getData( 5 ) )
		end
		if q:getData( 6 ) ~= nil then -- item_effect
			textfield_edit_effects_icon:setText( q:getData( 6 ) )
		end
		if q:getData( 7 ) ~= nil then -- item_effect
			textfield_edit_effects_animation:setText( q:getData( 7 ) )
		end
				
		if q:getData( 8 ) ~= nil then
			-- print ("[edit_effects] statline ID : " ..  q:getData( 5 ) )
			stat_id = tonumber( q:getData( 8 ) )
		else
			stat_id = -1
		end
		
		if q:getData( 9 ) ~= nil then
			textfield_edit_effects_atk:setText( q:getData( 9 ) )
		end
		if q:getData( 10 ) ~= nil then
			textfield_edit_effects_def:setText( q:getData( 10 ) )
		end
		if q:getData( 11 ) ~= nil then
			textfield_edit_effects_mov:setText( q:getData( 11 ) )
		end
		if q:getData( 12 ) ~= nil then
			textfield_edit_effects_rng:setText( q:getData( 12 ) )
		end
		if q:getData( 13 ) ~= nil then
			textfield_edit_effects_dam:setText( q:getData( 13 ) )
		end
		if q:getData( 14 ) ~= nil then
			textfield_edit_effects_drn:setText( q:getData( 14 ) )
		end
		if q:getData( 15 ) ~= nil then
			textfield_edit_effects_sp:setText( q:getData( 15 ) )
		end
		if q:getData( 16 ) ~= nil then
			textfield_edit_effects_hp:setText( q:getData( 16 ) )
		end
		
		self.current_effect_id = tonumber( q:getData( 17 ) )
		
		window_edit_effects_data:setText("Effect Data ( ID " .. self.current_effect_id .." )")
		
	--[[
		textfield_edit_effects_atk
		textfield_edit_effects_def
		textfield_edit_effects_mov
		textfield_edit_effects_rng
		textfield_edit_effects_hp
		textfield_edit_effects_sp
		textfield_edit_effects_dam
		textfield_edit_effects_drn
	]]--
	end
end


function edit_effects:showDelete()
	-- print "[edit_effects] showDelete"
	-- show confirmation
end

function edit_effects:updateList()
	-- print "[edit_effects] updateList"
	listbox_edit_effects:clear()
	statement = "SELECT effect_name FROM table_effects WHERE 0 = 0 ORDER BY effect_type ASC, effect_name ASC"
	local q = sql:exe( statement )
	if q ~= nil then
		for i = 0, q:getRowCount()-1 do
			local n = i*q:getHeadCount()
				listbox_edit_effects:addItem( q:getData( i ) )
		end
	end
	sql:removeResult( q )
	window_edit_effects_data:setVisible( false )
end

-- end of file