-- Dungeon Tactics
-- Copyright 2012 lukas w. irwin [ lukas.w.irwin@gmail.com ]
-- This program is free software under the terms of the GNU General Public License version 3 or later.
-- edit_tiles.lua

edit_tiles = { ID = 0 }

-- print "[edit_tiles]"

-- creation
function edit_tiles:new (o)
	-- print "[edit_tiles] new edit_tiles"
	o = o or {}
	setmetatable(o, self)
	self.__index = self

	btn_w = 60
	btn_h = 30
	--
	-- list window
	--
	x = 10
	y = 60
	window_edit_tiles_list = sim:addWindow( 1000, xcore.x2drect(x, y, x+128, y+256+60), "Tile List")
	window_edit_tiles_list:setTitleBarVisible( false )		
	image_background_edit_list = sim:addImage( 0, texture_background_128x256, xcore.x2dpoint(0, 0),
		xcore.x2drect(0,0,64,64), xcore.xcolour(255,255,255,255) )
	image_background_edit_list:setParent( window_edit_tiles_list )
	
	-- list
	width = 118	
	x = 5
	y = 10
	height = 236
	listbox_edit_tiles = sim:addListbox( 1010, true, xcore.x2drect( x,y,x+width,y+height ) )
	listbox_edit_tiles:setParent( window_edit_tiles_list )
	listbox_edit_tiles:addItem("test")
	x = 0
	y = 256

	button_edit_tiles_edit = sim:addButton( 2102, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Edit" )
	button_edit_tiles_edit:setParent( window_edit_tiles_list )		
	button_edit_tiles_edit:setImage( button_small_texture )
	button_edit_tiles_edit:setPressedImage( button_small_pressed_texture )	

	x = x+ btn_w + 6
	button_edit_tiles_delete = sim:addButton( 2103, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Delete" )
	button_edit_tiles_delete:setParent( window_edit_tiles_list )		
	button_edit_tiles_delete:setImage( button_small_texture )
	button_edit_tiles_delete:setPressedImage( button_small_pressed_texture )	

	x = 0
	y = y + 30
	btn_w = 128
	-- add some buttons
	button_edit_tiles_add = sim:addButton( 2101, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Add" )
	button_edit_tiles_add:setParent( window_edit_tiles_list )	
	button_edit_tiles_add:setImage( button_texture )
	button_edit_tiles_add:setPressedImage( button_pressed_texture )	
	
	sim:bindGUI ( "button_edit_tiles_add_pressed", 2101, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "button_edit_tiles_edit_pressed", 2102, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "button_edit_tiles_delete_pressed", 2103, xcore.XGUI_BUTTON_CLICKED )

	--
	-- data window
	--
	x = 260
	y = 60
	window_edit_tiles_data = sim:addWindow( 1000, xcore.x2drect(x, y, x+380, y+400), "Tile Data")	

	-- tile_name
	-- tile_type
	-- tile_set
	-- tile_model
	-- tile_texture
	-- tile_scale
	-- tile_base
	
	y = 30
	x = 20	
	-- add input for name
	label_edit_tiles_name = sim:addText( 0, "Name", x, y, x+100, y+20 )
	label_edit_tiles_name:setParent( window_edit_tiles_data )
	x = x+110
	textfield_edit_tiles_name = sim:addEditbox( 20,  xcore.x2drect( x,y,x+200,y+20 ) )
	textfield_edit_tiles_name:setParent( window_edit_tiles_data )	

	y = y + 30
	x = 20		
	-- add inputs for tile type
	label_edit_tiles_type = sim:addText( 0, "Type", x, y, x+100, y+20 )
	label_edit_tiles_type:setParent( window_edit_tiles_data )
	x = x+110
	combobox_edit_tiles_type = sim:addCombobox( 100, xcore.x2drect(x, y, x+150, y+20 ) )
	combobox_edit_tiles_type:setParent( window_edit_tiles_data )
	combobox_edit_tiles_type:addItem("TILE_TYPE_CLEAR")
	combobox_edit_tiles_type:addItem("TILE_TYPE_ROUGH")
	combobox_edit_tiles_type:addItem("TILE_TYPE_START")	
	combobox_edit_tiles_type:addItem("TILE_TYPE_EXIT")
	combobox_edit_tiles_type:addItem("TILE_TYPE_BLOCK")
	combobox_edit_tiles_type:addItem("TILE_TYPE_UNUSED")
	combobox_edit_tiles_type:addItem("TILE_TYPE_ROAD")
	combobox_edit_tiles_type:addItem("TILE_TYPE_ROAD_EDGE")
	combobox_edit_tiles_type:addItem("TILE_TYPE_ROAD_OUTTER")
	combobox_edit_tiles_type:addItem("TILE_TYPE_ROAD_INNER")
	combobox_edit_tiles_type:addItem("TILE_TYPE_IMPASS")
	
	y = y + 30
	x = 20
	-- add inputs for tileset
	label_edit_tiles_set = sim:addText( 0, "Tileset", x, y, x+100, y+20 )
	label_edit_tiles_set:setParent( window_edit_tiles_data )
	x = x+110
	combobox_edit_tiles_set = sim:addCombobox( 100, xcore.x2drect(x, y, x+150, y+20 ) )
	combobox_edit_tiles_set:setParent( window_edit_tiles_data )
	combobox_edit_tiles_set:addItem("TILESET_DUNGEON")
	combobox_edit_tiles_set:addItem("TILESET_FOREST")
	combobox_edit_tiles_set:addItem("TILESET_CAVE")
	combobox_edit_tiles_set:addItem("TILESET_MAZE")
	combobox_edit_tiles_set:addItem("TILESET_CASTLE")
	
	y = y + 30
	x = 20		
	-- add inputs for model
	label_edit_tiles_model = sim:addText( 0, "Model", x, y, x+100, y+20 )
	label_edit_tiles_model:setParent( window_edit_tiles_data )
	x = x+110
	textfield_edit_tiles_model = sim:addEditbox( 20,  xcore.x2drect( x,y,x+200,y+20 ) )
	textfield_edit_tiles_model:setParent( window_edit_tiles_data )

	y = y + 30
	x = 20
	-- add inputs for texture
	label_edit_tiles_texture = sim:addText( 0, "Texture", x, y, x+100, y+20 )
	label_edit_tiles_texture:setParent( window_edit_tiles_data )
	x = x+110
	textfield_edit_tiles_texture = sim:addEditbox( 20,  xcore.x2drect( x,y,x+200,y+20 ) )
	textfield_edit_tiles_texture:setParent( window_edit_tiles_data )

	y = y + 30
	x = 20
	-- add inputs for scale
	label_edit_tiles_scale = sim:addText( 0, "Scale", x, y, x+100, y+20 )
	label_edit_tiles_scale:setParent( window_edit_tiles_data )
	x = x+110
	textfield_edit_tiles_scale = sim:addEditbox( 20,  xcore.x2drect( x,y,x+200,y+20 ) )
	textfield_edit_tiles_scale:setParent( window_edit_tiles_data )

	y = y + 30
	x = 20		
	-- add inputs for scale
	label_edit_tiles_height = sim:addText( 0, "Height", x, y, x+100, y+20 )
	label_edit_tiles_height:setParent( window_edit_tiles_data )
	x = x+110
	textfield_edit_tiles_height = sim:addEditbox( 20,  xcore.x2drect( x,y,x+200,y+20 ) )
	textfield_edit_tiles_height:setParent( window_edit_tiles_data )	

	y = y + 30
	x = 20		
	-- add inputs for base
	label_edit_tiles_base = sim:addText( 0, "Billboard", x, y, x+100, y+20 )
	label_edit_tiles_base:setParent( window_edit_tiles_data )
	x = x+110
	textfield_edit_tiles_base = sim:addEditbox( 20,  xcore.x2drect( x,y,x+200,y+20 ) )
	textfield_edit_tiles_base:setParent( window_edit_tiles_data )	

	y = y + 50
	btn_w = 160
	x = 120
	button_edit_tiles_save = sim:addButton( 2111, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Save" )
	button_edit_tiles_save:setParent( window_edit_tiles_data )		
	button_edit_tiles_save:setImage( button_texture )
	button_edit_tiles_save:setPressedImage( button_pressed_texture )

	sim:bindGUI ( "button_edit_tiles_save_pressed", 2111, xcore.XGUI_BUTTON_CLICKED )

	stat_id = -1
	self.mode = 1
	self.current_tile_id = -1

	self:hide()
	return o
end

function edit_tiles:hide()
	-- print "[edit_tiles] hide"
	window_edit_tiles_list:setVisible( false )
	window_edit_tiles_data:setVisible( false )
end

function edit_tiles:show()
	-- print "[edit_tiles] show"
	self:updateList()

	window_edit_tiles_list:setVisible( true )
	-- print "[edit_tiles] /show"
end

function edit_tiles:destroy()
	-- print "[edit_tiles] destroy"
	window_edit_tiles_list:destroy()
end

function edit_tiles:input()
	if sim:isGUI( "button_edit_tiles_add_pressed" ) then
		window_edit_tiles_data:setVisible( true )
		self:showAdd()
	end
	if sim:isGUI( "button_edit_tiles_edit_pressed" ) then
		window_edit_tiles_data:setVisible( true )
		self:showEdit()
	end
	if sim:isGUI( "button_edit_tiles_delete_pressed" ) then
		self:delete()
	end	
	if sim:isGUI( "button_edit_tiles_save_pressed" ) then
		self:save()
	end	
end

function edit_tiles:save()
	-- tile_name
	-- tile_type
	-- tile_set
	-- tile_model
	-- tile_texture
	-- tile_scale
	-- tile_base	
	
	if self.mode == 1 then
		query = " INSERT INTO table_tiles "
		query = query .. " ( tile_name, tile_type, tile_set, tile_model, tile_texture, tile_scale, tile_height, tile_base )"
		query = query .. "VALUES ( "
		query = query .. "'".. textfield_edit_tiles_name:getText() .. "', "
		query = query .. "'".. combobox_edit_tiles_type:getSelected() .. "', "
		query = query .. "'".. combobox_edit_tiles_set:getSelected() .. "', "
		query = query .. "'".. textfield_edit_tiles_model:getText() .. "', "
		query = query .. "'".. textfield_edit_tiles_texture:getText() .. "', "
		query = query .. "'".. textfield_edit_tiles_scale:getText() .. "', "
		query = query .. "'".. textfield_edit_tiles_height:getText() .. "', "		
		query = query .. "'".. textfield_edit_tiles_base:getText() .. "'"
		query = query .. " )"
		-- print( query )
		sql:exe( query )
	else
		query = "UPDATE table_tiles SET "
		query = query .. " tile_name = '" .. textfield_edit_tiles_name:getText() .. "', "
		query = query .. " tile_type = '" .. combobox_edit_tiles_type:getSelected() .. "', "
		query = query .. " tile_set = '" .. combobox_edit_tiles_set:getSelected() .. "', "
		query = query .. " tile_model = '" .. textfield_edit_tiles_model:getText() .. "', "
		query = query .. " tile_texture = '" .. textfield_edit_tiles_texture:getText() .. "', "
		query = query .. " tile_scale = '" .. textfield_edit_tiles_scale:getText() .. "', "
		query = query .. " tile_height = '" .. textfield_edit_tiles_height:getText() .. "', "		
		query = query .. " tile_base = '" .. textfield_edit_tiles_base:getText() .. "' "

		query = query .. " WHERE tile_id = " .. self.current_tile_id
		-- print( query )
		sql:exe( query )
	end
	self:updateList()
end

function edit_tiles:delete()
	if listbox_edit_tiles:getSelected() == -1 then return nil end
	n = listbox_edit_tiles:getItem( listbox_edit_tiles:getSelected() )
	-- print("[edit_tiles] delete tile : " .. n)
	
	query = "DELETE FROM table_tiles WHERE tile_name = '" ..  n .. "'"
	local q = sql:exe( query )
	
	self:updateList()
end

function edit_tiles:showAdd()
	self.mode = 1
	-- print "[edit_tiles] showAdd"
	-- show confirmation
	textfield_edit_tiles_name:setText("")
	combobox_edit_tiles_type:setSelected( 0 )
	combobox_edit_tiles_set:setSelected( 0 )
	textfield_edit_tiles_texture:setText("")
	textfield_edit_tiles_scale:setText("")
	textfield_edit_tiles_height:setText("")	
	textfield_edit_tiles_base:setText("")
	textfield_edit_tiles_model:setText("")
	
end

function edit_tiles:showEdit()
	self.mode = 2
	-- print "[edit_tiles] showEdit"
	
	-- tile_name
	-- tile_type
	-- tile_set
	-- tile_model
	-- tile_texture
	-- tile_scale
	-- tile_base

	
	-- show confirmation
	n = listbox_edit_tiles:getItem( listbox_edit_tiles:getSelected() )
	-- print("[edit_tiles] edit item : " .. n)
	query = "SELECT tile_name, tile_type, tile_set, tile_model, tile_texture, tile_scale, tile_height, tile_base, tile_id FROM table_tiles WHERE tile_name = '" ..  n .. "'"
	local q = sql:exe( query )
	if q ~= nil then
		if q:getData( 0 ) ~= nil then
			-- print ("[edit_tiles] name : " .. q:getData( 0 ) )
			textfield_edit_tiles_name:setText( q:getData( 0 ) )
		end
		if q:getData( 1 ) ~= nil then
			-- print ( q:getData( 1 ) )
			combobox_edit_tiles_type:setSelected( tonumber( q:getData( 1 ) )  )
		end
		if q:getData( 2 ) ~= nil then
			-- print ( q:getData( 2 ) )
			combobox_edit_tiles_set:setSelected( tonumber( q:getData( 2 ) )  )			
		end
		if q:getData( 3 ) ~= nil then
			textfield_edit_tiles_model:setText( q:getData( 3 ) )
		end
		if q:getData( 4 ) ~= nil then -- item_effect
			textfield_edit_tiles_texture:setText( q:getData( 4 ) )
		end		
		if q:getData( 5 ) ~= nil then
			textfield_edit_tiles_scale:setText( q:getData( 5 ) )
		end
		if q:getData( 6 ) ~= nil then
			textfield_edit_tiles_height:setText( q:getData( 6 ) )
		end
		if q:getData( 7 ) ~= nil then
			textfield_edit_tiles_base:setText( q:getData( 7 ) )
		end
		self.current_tile_id = tonumber( q:getData( 8 ) )
	end
end

function edit_tiles:showDelete()
	-- print "[edit_tiles] showDelete"
	-- show confirmation
end

function edit_tiles:updateList()
	-- print "[edit_tiles] updateList"
	listbox_edit_tiles:clear()
	statement = "SELECT tile_name FROM table_tiles WHERE 0 = 0 ORDER BY tile_set ASC, tile_name ASC"
	local q = sql:exe( statement )
	if q ~= nil then
		for i = 0, q:getRowCount()-1 do
			local n = i*q:getHeadCount()
				listbox_edit_tiles:addItem( q:getData( i ) )
		end
	end
	sql:removeResult( q )
	window_edit_tiles_data:setVisible( false )
end

-- end of file