-- Dungeon Tactics
-- Copyright 2012 lukas w. irwin [ lukas.w.irwin@gmail.com ]
-- This program is free software under the terms of the GNU General Public License version 3 or later.
-- history.lua

history = { ID = 0 }

-- print "[history]"

-- creation
function history:new (o)
	-- print "[history] new history"
	o = o or {}
	setmetatable(o, self)
	self.__index = self

	width = 512
	height = 512	
	
	-- what about gui text elements?
	x = 20
	y = screen_height - height - 25

	posx = 20
	posy = 	20

	chatbox_messages = sim:addChatbox( 0, xcore.x2drect( x,y, x+width,y+height ) )
	-- chatbox_messages:setVisible( false )
	chatbox_messages:setLife( 10000 )
	chatbox_messages:setFont( font_1 )
	
	self:hide()
	-- print "[history] new history"
	self.messages = {}
	
	return o
end

function history:addItem( t )
	-- print "[history] hide"
	chatbox_messages:addMessage( t, xcore.xcolour( 255, 255, 255, 255 ) )
	self.messages[ table.getn( self.messages ) + 1 ] = t
end

function history:hide()
	-- print "[history] hide"
	chatbox_messages:setVisible( false )
end

function history:show()
	-- print "[history] show"
	chatbox_messages:setVisible( true )
	-- print "[history] /show"
end

function history:destroy()
	-- print "[history] destroy"
	chatbox_messages:destroy()
end

function history:clear()
	-- print "[history] update unit history"
	-- chatbox_messages:clear()
end

-- end of file