-- Dungeon Tactics
-- Copyright 2012 lukas w. irwin [ lukas.w.irwin@gmail.com ]
-- This program is free software under the terms of the GNU General Public License version 3 or later.
-- inventory.lua

inventory = { ID = 0 }

-- print "[inventory]"

-- creation
function inventory:new (o)
	-- print "[inventory] new inventory"
	o = o or {}
	setmetatable(o, self)
	self.__index = self


	width = 128
	height = 256+30

	x = screen_width - width - 40
	y = 300
	-- TODO: add abilities listbox?
	-- listbox_abilities = sim:addListbox( 2203, true, xcore.x2drect(x+10, y, x+width-50, y+180 ) )
	inventory_window = sim:addWindow( 400, xcore.x2drect(x, y, x+width, y+height), "Inventory")
	inventory_window:setTitleBarVisible( false )

	image_background_specials = sim:addImage( 0, texture_background_128x256, xcore.x2dpoint(0, 0),
		xcore.x2drect(0,0,64,64), xcore.xcolour(255,255,255,255) )
	image_background_specials:setParent( inventory_window )

	width = 118	
	x = 5
	y = 10
	height = 240	
	listbox_inventory =  sim:addListbox( 0, true, xcore.x2drect(x, y, x+width, y+height) )
	listbox_inventory:setParent( inventory_window )
	
	x = 0
	y = 256
	width = 128	
	button_inventory_use = sim:addButton( 403, xcore.x2drect( x, y, x+width, y+30 ), "Use Item" )
	button_inventory_use:setParent( inventory_window )
	button_inventory_use:setImage( button_texture )
	button_inventory_use:setPressedImage( button_pressed_texture )

	sim:bindGUI ( "button_inventory_use_pressed", 403, xcore.XGUI_BUTTON_CLICKED )	
	
	self:hide()
	-- print "[inventory] new inventory"
	
	return o
end

function inventory:hide()
	-- print "[inventory] hide"
	inventory_window:setVisible( false )
end

function inventory:show()
	-- print "[inventory] show"
	inventory_window:setVisible( true )
	self:update()
	-- print "[inventory] /show"
end

function inventory:destroy()
	-- print "[inventory] destroy"
	inventory_window:destroy()
end

function inventory:clear()
	-- print "[inventory] clear"
	listbox_inventory:clear()
end

function inventory:update()
	-- print("[state_game]  #items : " .. table.getn( local_user.inventory ) )
	listbox_inventory:clear()
	for i = 1, table.getn( local_user.inventory ) do
		-- print("[state_game] ".. local_user.inventory[ i ].item_name )
		listbox_inventory:addItem( local_user.inventory[ i ].item_name )
	end
end

function inventory:useItem()
	-- print "[inventory] useItem"
	-- print("[inventory] item index :" .. listbox_inventory:getSelected() )

	if listbox_inventory:getSelected() ~= -1 then
		-- print( "[inventory] mob :" .. game_map.mobs[selected].name .. " attempts to use " .. local_user.inventory[ listbox_inventory:getSelected()+1 ].item_name )
		if local_user.inventory[ listbox_inventory:getSelected()+1 ].item_type == ITEM_TYPE_WEAPON then
			print("[inventory] Item is a weapon of class " .. local_user.inventory[ listbox_inventory:getSelected()+1 ].item_class )
			print( game_map.mobs[selected].name .. " can use weapons of class " .. game_map.mobs[selected].wpn_skill .. " or lower.")
			if local_user.inventory[ listbox_inventory:getSelected()+1 ].item_class <=  game_map.mobs[ selected ].wpn_skill then
				print("[inventory] Weapon is equipable")
				game_history:addItem( game_map.mobs[selected].name .. " equipps the " .. local_user.inventory[ listbox_inventory:getSelected()+1 ].item_name )
				if game_map.mobs[selected].wep ~= nil then
					print("[inventory] mob already has weapon, place it in storage")
					local n = table.getn( local_user.inventory )+1
					local_user.inventory[ n ] =  game_map.mobs[selected].wep
				end

				game_map.mobs[selected]:equipWeapon( local_user.inventory[ listbox_inventory:getSelected()+1 ].item_id )

				table.remove( local_user.inventory, listbox_inventory:getSelected()+1 )
				self:update()
				menu_info:update()
			else
				print("Weapon can not be equiped on this character.")
				game_history:addItem( game_map.mobs[selected].name .. " can not equip " .. local_user.inventory[ listbox_inventory:getSelected()+1 ].item_name )				
			end
		elseif local_user.inventory[ listbox_inventory:getSelected()+1 ].item_type == ITEM_TYPE_ARMOR then
			-- print("Item is armor of class " .. local_user.inventory[ listbox_inventory:getSelected()+1 ].item_class )
			-- print( game_map.mobs[selected].name .. " can use armor of class " .. game_map.mobs[selected].arm_skill .. " or lower.")
			
			if local_user.inventory[ listbox_inventory:getSelected()+1 ].item_class <=  game_map.mobs[selected].arm_skill then
				-- print("Armor is equipable")
				game_history:addItem( game_map.mobs[selected].name .. " equipps the " .. local_user.inventory[ listbox_inventory:getSelected()+1 ].item_name )
				if game_map.mobs[selected].arm ~= nil then
					local n = table.getn( local_user.inventory )+1
					local_user.inventory[ n ] =  game_map.mobs[selected].arm
				end
				game_map.mobs[selected]:equipArmor( local_user.inventory[ listbox_inventory:getSelected()+1 ].item_id )
				
				table.remove( local_user.inventory, listbox_inventory:getSelected()+1 )
				self:update()
				menu_info:update()
			else
				-- print("Armor can not be equiped on this character.")
				game_history:addItem( game_map.mobs[selected].name .. " can not equip " .. local_user.inventory[ listbox_inventory:getSelected()+1 ].item_name )
			end
		elseif local_user.inventory[ listbox_inventory:getSelected()+1 ].item_type == ITEM_TYPE_ACCESSORY then
			-- print("Item is an accessory. Equip it!")
			game_history:addItem( game_map.mobs[selected].name .. " equipps the " .. local_user.inventory[ listbox_inventory:getSelected()+1 ].item_name )
			if game_map.mobs[selected].acc ~= nil then
				local n = table.getn( local_user.inventory )+1
				local_user.inventory[ n ] =  game_map.mobs[selected].acc
			end
			game_map.mobs[selected]:equipAccessory( local_user.inventory[ listbox_inventory:getSelected()+1 ].item_id )			

			table.remove( local_user.inventory, listbox_inventory:getSelected()+1 )
			self:update()
			menu_info:update()

		elseif local_user.inventory[ listbox_inventory:getSelected()+1 ].item_type == ITEM_TYPE_CONSUMABLE then
			-- print("[inventory] use consumable")
			game_history:addItem( game_map.mobs[selected].name .. " uses the " .. local_user.inventory[ listbox_inventory:getSelected()+1 ].item_name )
			
			if local_user.inventory[ listbox_inventory:getSelected()+1 ].stat_hp > 0 then
				-- health potion
				damage = local_user.inventory[ listbox_inventory:getSelected()+1 ].stat_hp
				game_history:addItem( game_map.mobs[ selected ].name .. " recovers " ..  math.abs(damage) .. " HP." )
				-- print damage effect
				p = game_map.mobs[ selected ].position
				i = table.getn( effects ) + 1
				effects[ i ] = visual:new()
				effects[ i ]:setPosition( xcore.x3dpoint( p.X, p.Y+5, p.Z ) )
				effects[ i ]:setType( VISTAL_TYPE_TEXT )
				effects[ i ]:setColour( 255, 0, 255, 0 )
				effects[ i ]:setText( "+" .. math.abs(damage) )
				game_map.mobs[ selected ].hp = game_map.mobs[ selected ].hp + damage
				if game_map.mobs[ selected ].hp >= game_map.mobs[ selected ]:getTotalHP() then
					game_map.mobs[ selected ].hp = game_map.mobs[ selected ]:getTotalHP()
				end				
			end
			if local_user.inventory[ listbox_inventory:getSelected()+1 ].stat_sp > 0 then
				-- spirit potion
				damage = local_user.inventory[ listbox_inventory:getSelected()+1 ].stat_sp
				game_history:addItem( game_map.mobs[ selected ].name .. " recovers " ..  math.abs(damage) .. " SP." )
				-- print damage effect
				p = game_map.mobs[ selected ].position
				i = table.getn( effects ) + 1
				effects[ i ] = visual:new()
				effects[ i ]:setPosition( xcore.x3dpoint( p.X, p.Y+5, p.Z ) )
				effects[ i ]:setType( VISTAL_TYPE_TEXT )
				effects[ i ]:setColour( 255, 0, 0, 255 )
				effects[ i ]:setText( "+" .. math.abs(damage) )
				game_map.mobs[ selected ].sp = game_map.mobs[ selected ].sp + damage
				if game_map.mobs[ selected ].sp >= game_map.mobs[ selected ]:getTotalSP() then
					game_map.mobs[ selected ].sp = game_map.mobs[ selected ]:getTotalSP()
				end							
			end
			table.remove( local_user.inventory, listbox_inventory:getSelected()+1 )
			self:update()
			menu_info:update()
		elseif local_user.inventory[ listbox_inventory:getSelected()+1 ].item_type == ITEM_TYPE_RELIC then
			-- lore items are added as bonus to score
			-- print("[inventory] view relic")
			game_history:addItem( "This item is not useable." )
		else
			-- print("[inventory] unknown item type")
		end
	else
		-- print "[inventory] no item selected"
	end
end

function inventory:addItem( i )
	item_count = table.getn( local_user.inventory )
	local_user.inventory[ item_count + 1 ] = item:new()
	local_user.inventory[ item_count + 1 ]:loadItem( i )
	game_history:addItem( "You have aqquired " .. local_user.inventory[ item_count + 1 ].item_name )
end

-- end of file