-- Dungeon Tactics
-- Copyright 2012 lukas w. irwin [ lukas.w.irwin@gmail.com ]
-- This program is free software under the terms of the GNU General Public License version 3 or later.
-- medical.lua
-- character medical...

medical = state:new()

-- print "[medical]"

-- creation
function medical:new (o)
	-- print "[medical] new medical"
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	self.sid = 0
	self.step = 1

	-- substates
	-- list   = 1
	-- add    = 2
	-- edit   = 3
	-- delete = 4

	--
	-- list
	--

	width = 250
	height = 290
	-- unit list table
	x = screen_width/2-200
	y = screen_height/2-140

	image_background_medical = sim:addImage( 0, texture_background_512x512, xcore.x2dpoint(x, y),
		xcore.x2drect(0,0,64,64), xcore.xcolour(255,255,255,255) )	
	x = x + 4
	y = y + 4	
	table_medical_roster = sim:addTable( 1299, true, xcore.x2drect( x+0, y+0, x+width, y+height ) )
	-- table_medical_roster:setParent( unitlist_window )
	table_medical_roster:addColumn( "Name       ", 1 )
	table_medical_roster:addColumn( "HP", 2 )		
	table_medical_roster:addColumn( "SP", 3 )

	btn_w = 128
	btn_h = 30
	-- add some buttons
	x = screen_width/2+80
	y = screen_height/2-140
	button_medical_heal = sim:addButton( 771, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Heal" )
	button_medical_heal:setVisible( false )
	button_medical_heal:setImage( button_texture )
	button_medical_heal:setPressedImage( button_pressed_texture )
	
	y = y + btn_h + 20
	button_medical_heal_all = sim:addButton( 772, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Heal All" )
	button_medical_heal_all:setVisible( false )
	button_medical_heal_all:setImage( button_texture )
	button_medical_heal_all:setPressedImage( button_pressed_texture )

	-- bind events to actions.
	sim:bindGUI ( "button_medical_heal_pressed", 771, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "button_medical_heal_all_pressed", 772, xcore.XGUI_BUTTON_CLICKED )	

	self:hide()
	return o
end

-- called on medical enter
function medical:show ()
	-- print "[medical] show medical"
	button_medical_heal:setVisible( true )
	button_medical_heal_all:setVisible( true )
	table_medical_roster:setVisible( true )
	image_background_medical:setVisible( true )

	text_title:setVisible( true )
	text_title:setText( "Temple" )
	image_background_title:setVisible( true )

	self:updateGroup()
end

-- called on medical exit
function medical:hide ()
	-- print "[medical] hide medical"
	button_medical_heal:setVisible( false )
	button_medical_heal_all:setVisible( false )
	table_medical_roster:setVisible( false )
	image_background_medical:setVisible( false )
	text_title:setVisible( false )
	text_title:setText( "" )
	image_background_title:setVisible( false )
end

function medical:heal ()
	-- print "[medical] heal"
	local n = table_medical_roster:getSelected()
	if n ~= -1 then
		if tonumber( table_medical_roster:getCellText( table_medical_roster:getSelected(), 3 ) ) > 0 then
			if local_user.gold >= tonumber( self.character_data[ n ]["cost"] ) then
				-- print( "heal mob : " .. table_medical_roster:getCellText( table_medical_roster:getSelected(), 0 ) )
				-- print( "cost : " .. table_medical_roster:getCellText( table_medical_roster:getSelected(), 3 ) )

				query = "UPDATE table_characters SET "
				query = query .. " character_hp = " .. self.character_data[ n ]["hp_max"] .. ", "
				query = query .. " character_sp = " .. self.character_data[ n ]["sp_max"] .. ", "
				query = query .. " character_status = 0, "
				query = query .. " character_state = 0 "
				query = query .. " WHERE character_id = " .. self.character_data[ n ]["id"]

				-- print ( query )
				q = sql:exe( query )
				-- remove gold from user
				local_user.gold = local_user.gold - tonumber( self.character_data[ n ]["cost"] )
				local_user:save()
			else
				print("not enough gold to heal selected character.")
			end
		end
	else
		-- print("no mob selected")
	end
	self:updateGroup()
end

function medical:healAll ()
	-- print "[medical] heal all"
	for i = 0, table.getn( self.character_data ) do
		if local_user.gold >= tonumber( self.character_data[ i ]["cost"] ) then
			-- print( "heal mob : " .. table_medical_roster:getCellText( table_medical_roster:getSelected(), 0 ) )
			-- print( "cost : " .. table_medical_roster:getCellText( table_medical_roster:getSelected(), 3 ) )

			query = "UPDATE table_characters SET "
			query = query .. " character_hp = " .. self.character_data[ i ]["hp_max"] .. ", "
			query = query .. " character_sp = " .. self.character_data[ i ]["sp_max"] .. ", "
			query = query .. " character_status = 0, "
			query = query .. " character_state = 0 "
			query = query .. " WHERE character_id = " .. self.character_data[ i ]["id"]

			-- print ( query )
			q = sql:exe( query )
			-- remove gold from user
			local_user.gold = local_user.gold - tonumber( self.character_data[ i ]["cost"] )
			local_user:save()
		else
			print("not enough gold to heal selected character.")
		end
	end
	self:updateGroup()	
end

function medical:updateGroup() -- update group
	-- print("\n[medical] updateGroup")
	table_medical_roster:clear()
	table_medical_roster:addColumn( "Name     ", 1 )
	table_medical_roster:addColumn( "HP  ", 2 )		
	table_medical_roster:addColumn( "SP  ", 3 )
	table_medical_roster:addColumn( "Cost ", 3 )

	self.character_data = {}
	
	if self.group_id ~= -1 then
		statement =             " SELECT character_id, character_name, character_hp, character_sp, character_level, stat_hp, stat_sp, class_name "
		statement = statement .." FROM table_characters "
		statement = statement .." LEFT JOIN table_classes ON character_class = class_id "
		statement = statement .." LEFT JOIN table_stats ON class_stat = stat_id "
		statement = statement .." WHERE character_owner_id = 1 "

		-- print( statement )
		local q = sql:exe( statement )

		if q ~= nil then
			-- print ("returned " .. q:getRowCount() .. " rows ")		
			for i = 0, q:getRowCount()-1 do
				local n = i*q:getHeadCount()
				table_medical_roster:addRow( i+1 )
				-- print("character_id : " .. 		q:getData( n+0 ) )
				-- print("character_name : " .. 		q:getData( n+1 ) )
				-- print("class_name : " .. 		q:getData( n+7 ) )
				-- print("character_hp : " .. 		q:getData( n+2 ) )
				-- print("character_sp : " .. 		q:getData( n+3 ) )
				local hp = 0
				local hp_max = 0
				local sp = 0
				local sp_max = 0
				local cost = 0
				local level = 0

				if q:getData( n+1 ) ~= nil then table_medical_roster:setCellText ( i, 0, q:getData( n+1 ) ) end
			
				
				if q:getData( n+2 ) ~= nil then
					hp = tonumber( q:getData( n+2 ) )
					hp_max = tonumber( q:getData( n+4 ) )* tonumber( q:getData( n+5 ) )
					level = tonumber( q:getData( n+4 ) )
					table_medical_roster:setCellText ( i, 1, q:getData( n+2 ) .. "/" .. tonumber( q:getData( n+4 ) )* tonumber( q:getData( n+5 ) ) )
				end
				if q:getData( n+3 ) ~= nil then 
					sp = tonumber( q:getData( n+3 ) )
					sp_max = tonumber( q:getData( n+4 ) )* tonumber( q:getData( n+6 ) )
					table_medical_roster:setCellText ( i, 2, q:getData( n+3 ) .. "/" .. tonumber( q:getData( n+4 ) )* tonumber( q:getData( n+6 ) ) )
				end
				if hp > 0 then
					cost = (hp_max - hp) + (sp_max - sp)
				else
					cost = 25 * level

				end

				self.character_data[ i ] = {}
				self.character_data[ i ]["id"] = q:getData( n+0 )
				self.character_data[ i ]["class"] = q:getData( n+7 )
				self.character_data[ i ]["hp_max"] = hp_max
				self.character_data[ i ]["sp_max"] = sp_max
				if self.character_data[ i ]["class"] == "Knight" and cost ~= 0 then
					cost = 1
				end			

				self.character_data[ i ]["cost"] = cost
				table_medical_roster:setCellText ( i, 3, cost )
			end	
		end
		sql:removeResult( q )		
	end
end

-- eof