-- Dungeon Tactics
-- Copyright 2012 lukas w. irwin [ lukas.w.irwin@gmail.com ]
-- This program is free software under the terms of the GNU General Public License version 3 or later.
-- state_load.lua

state_load = state:new()

-- creation
function state_load:new (o)
	-- print "[state_load] new state_load"
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	substate = 0

	x = 170
	y = (screen_height/2 - 256) + 20

	btn_w = 200
	btn_h = 40
	
	x = screen_width/2-(btn_w/2)
	y = screen_height-128
	button_load_exit = sim:addButton( 901, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Back" )
	button_load_exit:setVisible( false )
	sim:bindGUI ( "button_load_exit_pressed", 901, xcore.XGUI_BUTTON_CLICKED )

	return o
end

-- called on state_load enter
function state_load:enter ()
	-- print "[state_load] enter state_load"
	self:show()
	-- menu_text:setText("About")

	-- data_text:setText( txt )
	-- print "[state_load] /enter"
end

-- called on state_load exit
function state_load:exit ()
	-- print "[state_load] exit state_load"
	self:hide()

end

function state_load:show ()
	print "[state_load] show"

	button_load_exit:setVisible( true )

end

function state_load:hide ()
	print "[state_load] hide"
	button_load_exit:setVisible( false )
end

-- called to advance state_load
function state_load:input ()
	-- print ( "[state_load] input")
	r = ENUM_ABOUT
	if sim:isKey( "key_pressed_exit_state" ) then r = ENUM_MENU end
	if sim:isGUI( "button_load_exit_pressed" ) then return ENUM_MENU end

	sim:update()
	return r
end

-- called when changing state_load
function state_load:transition ( i ) -- transition to state_load v
	print "[state_load] transition"
end
