-- Dungeon Tactics
-- Copyright 2012 lukas w. irwin [ lukas.w.irwin@gmail.com ]
-- This program is free software under the terms of the GNU General Public License version 3 or later.
-- state_options.lua

state_options = state:new()

-- creation
function state_options:new (o)
	-- print "[state_options] new state_options"
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	self.sid = ENUM_OPTIONS
	
	btn_w = 200
	btn_h = 40
	
	x = screen_width/2-(btn_w/2)
	y = screen_height-100

	-- bind events to actions.

	return o
end

-- called on state_options enter
function state_options:enter ()
	-- print "[state_options] enter state_options"
	-- create everything
	tw = 200 -- use screensize to place & size everything
	th = 200
	window_w = 350
	window_h = 300

	x = screen_width/2 - window_w/2
	y = screen_height/2- window_h/2
	
	-- x = 0
	-- y = 0
	button_w = 128
	button_h = 32

	-- menu_text:setText("Options")
	-- accent_image_mid:setVisible( true )
	-- accent_image_side:setVisible( true )
	-- menu_text:setVisible( true )
	
	-- y = (screen_height/2 - 128)

	-- Video Settings
	y = y + 20
	text_options_video = sim:addText( 0, "Video Settings", x, y, x+tw, y+th )
	-- text_options_video:setFont( font_1 )
	text_options_video:setColour( xcore.xcolour( 255, 255, 255, 255 ) )

	y = y + 20
	text_options_res = sim:addText( 0, "Display Resolution :", x+20, y, x+tw, y+th )
	-- text_options_res:setFont( font_1 )
	text_options_res:setColour( xcore.xcolour( 255, 255, 255, 255 ) )

	combobox_options_res = sim:addCombobox( 0, xcore.x2drect( x+240, y, x+340, y+20 ) )
	
	combobox_options_res:addItem( "800x600" )
	combobox_options_res:addItem( "960x600" )
	combobox_options_res:addItem( "1024x768" )
	combobox_options_res:addItem( "1152x864" )
	combobox_options_res:addItem( "1280x768" )
	combobox_options_res:addItem( "1280x800" )
	combobox_options_res:addItem( "1280x960" )
	combobox_options_res:addItem( "1280x1024" )
	combobox_options_res:addItem( "1366x768" )
	combobox_options_res:addItem( "1440x900" )
	combobox_options_res:addItem( "1600x1200" )

	-- y = y + 20
	-- checkbox_options_shadows = sim:addCheckbox( 0, true, "Shadows", x+20, y, x+tw, y+button_h )
	y = y + 20
	checkbox_options_vsynch = sim:addCheckbox( 0, true, "vSynch", x+20, y, x+tw, y+button_h )
	y = y + 20
	checkbox_options_fullscreen = sim:addCheckbox( 0, false, "Full Screen", x+20, y, x+tw, y+button_h )

	-- audio Settings
	-- y = y + 40
	-- text_options_audio = sim:addText( 0, "Audio Settings", x, y, x+tw, y+th )
	-- text_options_audio:setFont( font_1 )
	-- text_options_audio:setColour( xcore.xcolour( 255, 255, 255, 255 ) )

	-- y = y + 20
	-- text_options_sfx = sim:addText( 0, "Sound Effects :", x+20, y, x+tw, y+th )
	-- text_options_sfx:setFont( font_1 )
	-- text_options_sfx:setColour( xcore.xcolour( 255, 255, 255, 255 ) )

	y = y + 40
	text_options_game = sim:addText( 0, "Game Settings", x, y, x+200, y+20 )
	text_options_game:setFont( font_1 )
	text_options_game:setColour( xcore.xcolour( 255, 255, 255, 255 ) )

	x = x + 20
	y = y + 20
	text_options_cam_speed = sim:addText( 0, "Camera Speed", x, y, x+200, y+20  )
	x = x + 120

	scrollbar_cam_speed = sim:addScrollbar(104, true, xcore.x2drect(x, y, x+200, y+20 ))
	scrollbar_cam_speed:setMax(1000)
	scrollbar_cam_speed:setMin(1)

	
	x = screen_width/2 - window_w/2
	y = y + 20
	checkbox_options_rotate = sim:addCheckbox( 0, false, "Press to rotate", x+20, y, x+tw, y+button_h )

	x = screen_width/2 - window_w/2
	y = y + 40
	text_options_sound = sim:addText( 0, "Sound Settings", x, y, x+200, y+20 )
	text_options_sound:setFont( font_1 )
	text_options_sound:setColour( xcore.xcolour( 255, 255, 255, 255 ) )	

	x = x + 20
	y = y + 20
	text_options_music_vol = sim:addText( 0, "Music Volume", x, y, x+200, y+20  )
	x = x + 120

	scrollbar_music_vol = sim:addScrollbar(104, true, xcore.x2drect(x, y, x+200, y+20 ))
	scrollbar_music_vol:setMax(100)
	scrollbar_music_vol:setMin(0)

	x = screen_width/2 - window_w/2
	x = x + 20
	y = y + 20	
	text_options_sfx_vol = sim:addText( 0, "Sfx Volume", x, y, x+200, y+20  )
	x = x + 120

	scrollbar_sfx_vol = sim:addScrollbar(104, true, xcore.x2drect(x, y, x+200, y+20 ))
	scrollbar_sfx_vol:setMax(100)
	scrollbar_sfx_vol:setMin(0)

	-- Accept & Cancel buttons
	btn_w = 128
	btn_h = 20
	-- add some buttons
	x = screen_width/2-btn_w-10
	y = y + 100
	button_options_cancel = sim:addButton( 202, xcore.x2drect( x, y, x+(button_w), y+(button_h) ), "Cancel" )
	button_options_cancel:setImage( button_texture )
	button_options_cancel:setPressedImage( button_pressed_texture )

	x = x + btn_w + 20
	button_options_accept = sim:addButton( 201, xcore.x2drect( x, y, x+(button_w), y+(button_h) ), "Apply" )
	button_options_accept:setImage( button_texture )
	button_options_accept:setPressedImage( button_pressed_texture )

	sim:bindGUI ( "button_options_accept_pressed", 201, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "button_options_cancel_pressed", 202, xcore.XGUI_BUTTON_CLICKED )

	-- menu_text:setText("Options")
	-- data_text:setText("Please note that changes made to some options may require you to restart the program.")
	text_title:setVisible( true )
	text_title:setText( "Options" )
	image_background_title:setVisible( true )

	self:loadOptions()
end

-- called on state_options exit
function state_options:exit ()
	-- print "[state_options] exit state_options"

	-- destroy everything
	button_options_accept:destroy()
	button_options_cancel:destroy()

	combobox_options_res:destroy()
	text_options_res:destroy()
	-- text_options_audio:destroy()
	-- text_options_sfx:destroy()
	text_options_game:destroy()	
	text_options_video:destroy()
	text_options_cam_speed:destroy()
	scrollbar_cam_speed:destroy()

	text_options_sound:destroy()
	text_options_sfx_vol:destroy()
	text_options_music_vol:destroy()
	scrollbar_sfx_vol:destroy()
	scrollbar_music_vol:destroy()	

	checkbox_options_fullscreen:destroy()
	checkbox_options_vsynch:destroy()
	checkbox_options_rotate:destroy()
	text_title:setVisible( false )
	text_title:setText( "" )
	image_background_title:setVisible( false )

	-- print "[state_options] /exit"
end

-- called to advance state_options
function state_options:input ()
	-- print ( "[state_options] input")
	r = ENUM_OPTIONS

	if sim:isGUI( "button_options_accept_pressed" ) then
		-- print "button_options_accept"
		r = ENUM_MENU
		-- insert data into database.
		self:saveOptions()
	end

	if sim:isGUI( "button_options_cancel_pressed" ) then
		-- print "button_options_exit_pressed"
		r = ENUM_MENU 
	end
	
	if sim:isKey( "key_pressed_exit_state" ) then r = ENUM_MENU end

	sim:update()

	return r
end

function state_options:loadOptions()
	-- print "[state_options] loadOptions"
	statement = "SELECT _system_fullscreen, _system_resx, _system_resy, _system_vsynch, _system_camtype, _system_camspeed, _system_sfx, _system_music FROM _system WHERE _system_id = 1 "
	-- print ( query )
	sql:exe( query )

	local q = sql:exe( statement )
	if q == nil then return end

	-- print ("_system_fullscreen:" .. q:getData( 0 ) )
	-- print ("_system_resx:" .. q:getData( 1 ) )
	-- print ("_system_resy:" .. q:getData( 2 ) )
	-- print ("_system_vsynch:" .. q:getData( 3 ) )
	-- print ("_system_camtype:" .. q:getData( 4 ) )
	-- print ("_system_camspeed:" .. q:getData( 5 ) )
	-- print ("_system_sfx:" .. q:getData( 6 ) )
	-- print ("_system_music:" .. q:getData( 7 ) )	

	fs = tonumber( q:getData( 0 ) )
	rx = tonumber( q:getData( 1 ) )
	ry = tonumber( q:getData( 2 ) )
	sh = tonumber( q:getData( 3 ) )
	cam_type = tonumber( q:getData( 4 ) )
	cam_speed = tonumber( q:getData( 5 ) )
	sound_sfx_vol = tonumber( q:getData( 6 ) )
	sound_sfx_music = tonumber( q:getData( 7 ) )	
	
	if rx == 800 and ry == 600 then
		combobox_options_res:setSelected( 0 )
	elseif rx == 960 and ry == 600 then
		combobox_options_res:setSelected( 1 )
	elseif rx == 1024 and ry == 768 then
		combobox_options_res:setSelected( 2 )
	elseif rx == 1152 and ry == 864  then
		combobox_options_res:setSelected( 3 )
	elseif rx == 1280 and ry == 768  then
		combobox_options_res:setSelected( 4 )
	elseif rx == 1280 and ry == 800  then
		combobox_options_res:setSelected( 5 )
	elseif rx == 1280 and ry == 960  then
		combobox_options_res:setSelected( 6 )
	elseif rx == 1280 and ry == 1024  then
		combobox_options_res:setSelected( 7 )
	elseif rx == 1366 and ry == 768  then
		combobox_options_res:setSelected( 8 )
	elseif rx == 1440 and ry == 900  then
		combobox_options_res:setSelected( 9 )
	elseif rx == 1600 and ry == 1200 then
		combobox_options_res:setSelected( 10 )
	end

	if fs == 0 then checkbox_options_fullscreen:setChecked( false ) else checkbox_options_fullscreen:setChecked( true ) end
	if sh == 0 then checkbox_options_vsynch:setChecked( false ) else checkbox_options_vsynch:setChecked( true ) end
	if cam_type == 0 then checkbox_options_rotate:setChecked( false ) else checkbox_options_rotate:setChecked( true ) end
	scrollbar_cam_speed:setPos( cam_speed )
	scrollbar_sfx_vol:setPos( sound_sfx_vol )
	scrollbar_music_vol:setPos( sound_music_vol )	
end

function state_options:saveOptions()
	if checkbox_options_fullscreen:isChecked() == false then fs = 0 else fs = 1 end
	if checkbox_options_vsynch:isChecked() == false then sh = 0 else sh = 1 end
	if checkbox_options_rotate:isChecked() == false then cam_type = 0 else cam_type = 1 end
	cam_speed = scrollbar_cam_speed:getPos()
	sound_sfx_vol = scrollbar_sfx_vol:getPos()
	sound_music_vol = scrollbar_music_vol:getPos()

	if combobox_options_res:getSelected() == 0 then
		rx = 800
		ry = 600
	elseif combobox_options_res:getSelected() == 1 then
		rx = 960
		ry = 600			
	elseif combobox_options_res:getSelected() == 2 then
		rx = 1024
		ry = 768
	elseif combobox_options_res:getSelected() == 3 then
		rx = 1152
		ry = 864
	elseif combobox_options_res:getSelected() == 4 then
		rx = 1280
		ry = 768
	elseif combobox_options_res:getSelected() == 5 then
		rx = 1280
		ry = 800
	elseif combobox_options_res:getSelected() == 6 then
		rx = 1280
		ry = 960
	elseif combobox_options_res:getSelected() == 7 then
		rx = 1280
		ry = 1024
	elseif combobox_options_res:getSelected() == 8 then
		rx = 1366
		ry = 768
	elseif combobox_options_res:getSelected() == 9 then
		rx = 1440
		ry = 900
	elseif combobox_options_res:getSelected() == 10 then
		rx = 1600
		ry = 1200
	end

	query = "UPDATE _system SET "
	query = query .. " _system_fullscreen = " .. fs .. ", "
	query = query .. " _system_resx = " .. rx .. ", "
	query = query .. " _system_resy = " .. ry .. ", "
	query = query .. " _system_vsynch = " .. sh .. ", "
	query = query .. " _system_camtype = " .. cam_type .. ", "
	query = query .. " _system_camspeed = " .. cam_speed .. ", "
	query = query .. " _system_sfx = " .. sound_sfx_vol .. ", "	
	query = query .. " _system_music = " .. sound_music_vol .. " "	
	
	-- print ( query )
	sql:exe( query )
	
	-- hmm...
	updateSoundLevels()
end

-- called when changing state_options
function state_options:transition ( i ) -- transition to state_options v
	-- print "[state_options] transition"
end