-- xenjine layer 2 network tutorial 2b (p-shooter server)
-- c2008-2009 lukas irwin | sysop [ at ] xhrit.com
-- dialogbox.lua
-- 03/14/2011 - file created
-- derrived from tutorial sql 2 editwindow.lua
-- i needed an easy to use dialog box implimintation so i decided to reporpuse some old code ^^
-- 

dialogbox = { ID = 0 }

print "[dialogbox]"

-- creation
function dialogbox:new (o)
	-- print "[pawn] new pawn"
	o = o or {}
	setmetatable(o, self)
	self.__index = self

	self.window_elements = {}
	self.caption = "" -- TODO: figure out how to set this?

	self.width = 300
	self.height = 300
	self.pos_x = screen_width / 2 - ( self.width / 2 )
	self.pos_y = screen_height / 2 - ( self.height / 2 )
	self.window_elements[1] = sim:addWindow( 100, xcore.x2drect( self.pos_x, self.pos_y, self.pos_x + self.width, self.pos_y + self.height), self.caption )

	self.ec = 0 -- dynamic element count
	self.rows = 0 -- total number ov elements

	self.edit_element = -1

	return o
end

function dialogbox:destroy ()
	-- print "[dialogbox] destroy"
	i = table.getn( self.window_elements )
	for n = i, 1, -1  do
		self.window_elements[n]:destroy()
	end
end

function dialogbox:addMessage ( message ) -- adds a message
	-- print "dialogbox:addConfirmMessage"
	self.rows = self.rows + 2

	i = table.getn( self.window_elements ) + 1
	self.window_elements[ i ] = sim:addText( 101, message , 20, 30, 200, 200 )
	self.window_elements[ i ]:setParent( self.window_elements[1] )
	self.window_elements[ i ]:setColour( xcore.xcolour(255, 0, 0, 0) )
	-- print "/dialogbox:addConfirmMessage"
end

function dialogbox:addEditBox () -- adds a text box
	print "dialogbox:addEditBox"
	self.rows = self.rows + 4

	i = table.getn( self.window_elements ) + 1
	self.edit_element = i
	self.window_elements[ i ] = sim:addEditbox( 102, xcore.x2drect( 20, 30, 240, 120 ) )
	self.window_elements[ i ]:setParent( self.window_elements[1] )
	self.window_elements[ i ]:setMultiLine( true )
	-- self.window_elements[ i ]:setColour( xcore.xcolour(255, 0, 0, 0) )
	print "/dialogbox:addConfirmMessage"
end

function dialogbox:getEditText() -- gets text from last textbox added
	print "dialogbox:getEditText"
	if self.edit_element ~= -1 then
		a = self.window_elements[ self.edit_element ]:getText()
		self.edit_element = -1
		return a
	else
		print ( "error, no edit box in window" )
	end
	return nil
end

function dialogbox:addInputElement ( key, value ) -- adds an input with key and value pair
	-- print "dialogbox:addInputElement"
	self.rows = self.rows + 1

	x = 20
	y = self.rows * 25

	i = table.getn( self.window_elements ) + 1
	-- add label
	self.window_elements[ i ] = sim:addText( 101, key ,  x, y, x+100, y+20  )
	self.window_elements[ i ]:setParent( self.window_elements[1] )
	self.window_elements[ i ]:setColour( black )
	x = 140

	-- add edit box
	i = table.getn( self.window_elements ) + 1
	-- print ("i:" .. i)
	self.window_elements[ i ] = sim:addEditbox( 420,  xcore.x2drect(  x, y, x+100, y+20 ) )
	self.window_elements[ i ]:setParent( self.window_elements[1] )
	self.window_elements[ i ]:setText( value )
end

function dialogbox:addButton ( button_text, button_target ) -- adds button with configurable text and target
	print "dialogbox:addButton"
	print ( button_text ..", " .. button_target )
	self.rows = self.rows + 1

	x = 20
	y = self.rows * 25
	i = table.getn( self.window_elements ) + 1
	self.window_elements[ i ] = sim:addButton( 1001, xcore.x2drect(  x, y, x+100, y+20  ), button_text )
	self.window_elements[ i ]:setParent( self.window_elements[1] )

	sim:bindGUI ( button_target, 1001, xcore.XGUI_BUTTON_CLICKED )

	self.window_elements[ 1 ]:setSize( 260, y+30 )
end

function dialogbox:addButtons () -- adds accept / cancel buttons
	-- print "dialogbox:addButtons"
	self.rows = self.rows + 1

	x = 20
	y = self.rows * 25
	i = table.getn( self.window_elements ) + 1
	self.window_elements[ i ] = sim:addButton( 1003, xcore.x2drect(  x, y, x+100, y+20  ), "Accept" )
	self.window_elements[ i ]:setParent( self.window_elements[1] )

	x = 140
	i = table.getn( self.window_elements ) + 1
	self.window_elements[ i ] = sim:addButton( 1002, xcore.x2drect(  x, y, x+100, y+20  ), "Cancel" )
	self.window_elements[ i ]:setParent( self.window_elements[1] )

	sim:bindGUI ( "dialogbox_cancel", 1002, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "dialogbox_accept", 1003, xcore.XGUI_BUTTON_CLICKED )

	self.window_elements[ 1 ]:setSize( 260, y+30 )
end

function dialogbox:removeButtons()
	-- print "removeButton"
	i = table.getn( self.window_elements )
	-- print ( "no elements" .. i )
	for n = 1, i  do
		-- print ("n:" .. n )
		if self.window_elements[n]:getType() == xcore.XELEMENT_TYPE_BUTTON then
			-- print ("type match")
			self.window_elements[ n ]:destroy()
			table.remove ( self.window_elements, n )
			return 0
		end
	end
	return 1
end

function dialogbox:setSize ( w, h)
	self.window_elements[1]:setSize( w, h )
end

function dialogbox:setText ( t )
	self.window_elements[1]:setText( t )
end