-- xenjine layer 2  : p-shooter client tutorial
-- c2007 : lukas irwin : sysop [ at ] xhrit.com
-- pawn.lua

pawn = { ID = 0 }

print "[pawn]"

-- creation
function pawn:new (o)
	-- print "[pawn] new pawn"
	o = o or {}
	setmetatable(o, self)
	self.__index = self

	self.ID       = 0
	self.owner_ID  = 0
	self.type  = 0
	self.valid  = 0
	self.position = xcore.x3dpoint( 0, 0, 0 )
	self.rotation = xcore.x3dpoint( 0, 0, 0 )
	self.hasTrail = 0

	return o
end

function pawn:setGraphic( mesh_filename, texture_filename )
	-- print "[pawn] setGraphic"
	-- load graphics; mesh and texture
	-- TODO : FIXME!
	-- print ("[pawn] mesh filename : " .. mesh_filename )
	if (mesh_filename == "cube") then
		self.mesh = sim:addCubeMesh ( 0.02 )
		self.mesh:setScale( xcore.x3dpoint( 0.5, 0.5, 0 ) )
	else
		self.mesh = sim:addMesh ( 0, mesh_filename )
		self.mesh:setScale( xcore.x3dpoint( 1, 1, 1 ) )		
	end
	self.mesh:addTexture( texture_filename, 0 )
	self.mesh:setMaterialFlag( xcore.XMF_LIGHTING, false )
end


function pawn:setTrail()
	-- add a trail for shits and giggles.
	self.particles = sim:addParticleSystem(10, path .. "resources/fire.bmp")
	self.particles:setMaterialFlag( xcore.XMF_LIGHTING, false )
	self.particles:setMaterialFlag( xcore.XMF_ZWRITE_ENABLE, false )
	self.particles:setMaterialType( xcore.XMT_TRANSPARENT_ADD_COLOR )


	self.particles:createPointEmitter( xcore.x3dpoint(0, 0, 0), 10, 25,
		xcore.xcolour(255, 255, 255, 255), xcore.xcolour(100, 255, 255, 255),
		1200, 2000, 90, 2, 3 )
	self.particles:addFadeOutAffector( xcore.xcolour(0, 0, 0, 0), 1000 )

	self.hasTrail = 1
end


function pawn:setPosition( p )
	-- print "[pawn] setPosition"
	self.position = p
	self.mesh:setPosition( p )

	if self.hasTrail == 1 then
		self.particles:setPosition( p )
	end
end

function pawn:getPosition () return self.position end

function pawn:setRotation( r )
	-- print "[pawn] setRotation"
	self.rotation = r
	self.mesh:setRotation( r )
end

function pawn:getRotation () return self.rotation end

function pawn:setID ( n ) self.ID = n end
function pawn:getID () return self.ID end

function pawn:setOwner ( o ) self.owner_ID = o end
function pawn:getOwner () return self.owner_ID end

function pawn:setType ( t ) self.type = t end
function pawn:getType () return self.type end

function pawn:setValid ( v ) self.type = v end
function pawn:getValid () return self.type end

function pawn:destroy () 
	-- print "[pawn] destroy"
	self.mesh:destroy()
	if self.hasTrail == 1 then
		self.particles:destroy()
	end
end

