-- xenjine layer 2 network tutorial 2a (p-shooter-client)
-- c2007 : lukas irwin : sysop [ at ] xhrit.com
-- tutorial_statemachine.module

print "[client] p-shooter client demo"

-- define game state enums
ENUM_MENU = 1
ENUM_LOGIN = 2
ENUM_VALIDATE = 3
ENUM_HIGHSCORES = 4
ENUM_GAME = 5

-- a quick utility function ^^
path = "modules/shooter_client/"
function doload( f )
	print ("doing load ov file " .. f )
	x = loadfile ( path .. f )
	x()
end

-- utility objects
doload( "dialogbox.lua" )

-- state objects
doload( "statemachine.lua" )
doload( "state.lua" )

-- game states
doload( "state_menu.lua" )
doload( "state_login.lua" )
doload( "state_validate.lua" )
doload( "state_game.lua" )
doload( "state_highscores.lua" )

-- game objects
doload( "pawn.lua" )
doload( "user.lua" )
doload( "visual.lua" )

-- required
function init()
	-- print "[tutorial] init statemachine tutorial"
	screen_width = 800 -- this should be in  module settings
	screen_height = 600

	sim = xcore.xsimulation ( xcore.XDT_OPENGL , screen_width, screen_height, 16, false, true, true ) -- initalize simulation
	-- print "[tutorial] new statemachine"
	fsm = statemachine:new() -- initalize state machine

	-- print "[tutorial] new states"
	menu = state_menu:new()
	login = state_login:new()
	login = state_validate:new()
	game = state_game:new()
	highscores = state_highscores:new()

	-- print "[tutorial] add states to fsm"
	-- print ("[tutorial] count: " .. fsm:count())
	fsm:addState( state_menu )
	fsm:addState( state_login )
	fsm:addState( state_validate )
	fsm:addState( state_highscores )
	fsm:addState( state_game )
	-- print ("[tutorial] count: " .. fsm:count())

	-- print "[tutorial] set default state"
	fsm:setDefault( ENUM_MENU )

	sim:bindkey ( "quit_key_pressed", xcore.XKEY_ESCAPE )
end

-- required
function render()
	-- print "[tutorial] render"
	sim:render()
end

-- required
function update()
	-- print "update statemachine tutorial"
	fsm:step()
end

-- end of file