--   statemachine 1.2

print "[statemachine]?"

statemachine = { time = 0, current_state = 0, old = 0 }

print "[statemachine]"

-- creation
function statemachine:new (o)
	-- print "[statemachine] new statemachine"
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	self.states = {}
	return o
end

function statemachine:addState( s )
	-- print "[statemachine] addState"
	i = table.getn( self.states ) +1
	s:setId( i )
	self.states[ i ] = s
end

function statemachine:removeState( s )
	-- states.pop
end

function statemachine:setState( to )
	-- print "[statemachine] setState"
	self.current_state = to
end

function statemachine:setDefault( to )
	-- print "[statemachine] setDefault"
	self:setState( to )
end

function statemachine:step( delta ) -- TODO: fixed rate timestep; fix to delta
	-- print "[statemachine] Step"
	self.old = self.current_state
	-- print ( "[statemachine] State count : " .. table.getn( self.states ) )
	if self.current_state <= table.getn( self.states ) then
		-- print ( "[statemachine] self.current_state : " .. self.current_state )
		self.current_state = self.states[ self.current_state ]:input() -- operation
		-- print ( "[statemachine] next state : " .. self.current_state )
		if self.current_state ~= self.old then
			self.states[ self.old ]:transition( self.current_state )
			self.states[ self.old ]:exit()
			self.states[ self.current_state ]:enter()
		end
	else
		print ( "[error] invalid state id : " .. self.current_state )
	end

end

function statemachine:count() -- get state count
	return table.getn( self.states )
end

