-- state_menu object
-- lwi
-- ...

state_menu = state:new()

print "[state_menu]"

-- creation
function state_menu:new (o)
	print "[state_menu] new state_menu"
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	self.sid = 0

	sim:setWindowCaption( "Xenos Engine Tutorial Statemachine" )

	-- add a logo
	logo_texture = sim:getTexture( "modules/tutorial_graphics_1/resources/xenos_logo_small.tga" )
 	logo_image = sim:addImage( 0, logo_texture, xcore.x2dpoint(-20, -10),
		xcore.x2drect(0,0,64,64), xcore.xcolour(255,255,255,255) )
	
	-- add some static text describing the demo
	text = [[
	Xenos Engine Tutorial Statemachine
	
	This demo will show you how to use subclasses to 
	build a statemachine to switch between game states
	such as main menu, highscores, options, and loadscreens.
	
	Current state is 'Menu'.
	
	Press button to change state.
	]]
	text_menu = sim:addText( 0, text, 50, 50, 600, 600)

	-- add a window
	-- print "add a window..."
	-- w = sim:addWindow( 100, xcore.x2drect( 20, 20, 200, 200 ), "Window test" )
	-- print "end"

	-- add some buttons
	b1 = sim:addButton( 101, xcore.x2drect( 10, 210, 100, 240 ), "Quit" )
	b2 = sim:addButton( 102, xcore.x2drect( 10, 250, 100, 290 ), "New Game" )
	b3 = sim:addButton( 103, xcore.x2drect( 10, 300, 100, 340 ), "High Scores" )

	-- bind events to actions.
	sim:bindGUI ( "quit_button_pressed", 101, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "new_game_button_pressed", 102, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "high_scores_button_pressed", 103, xcore.XGUI_BUTTON_CLICKED )

	return o
end

-- called on state_menu enter
function state_menu:enter ()
	print "[state_menu] enter state_menu"
	-- show everything
	-- w:setVisible( true )
	b1:setVisible( true )
	b2:setVisible( true )
	b3:setVisible( true )
	text_menu:setVisible( true )
	self.time = 0
end

-- called on state_menu exit
function state_menu:exit ()
	print "[state_menu] exit state_menu"
	-- hide everything
	-- w:setVisible( false )
	b1:setVisible( false )
	b2:setVisible( false )
	b3:setVisible( false )
	text_menu:setVisible( false )

	self.time = 0
end

-- called to advance state_menu
function state_menu:input ()
	-- print ( "[state_menu] input")
	self.time = self.time + 1
	
	-- if self.time > 50 then
	-- 	self.time = 0
	-- 	print "waited 50 seconds, playing game..."
	-- 	return ENUM_GAME -- enum_menu
	-- end
	r = ENUM_MENU -- 1
	-- act upon keypress and user interface events
	-- if sim:isKey( "quit_key_pressed" ) then sim:destroy() end
	if sim:isGUI( "quit_button_pressed" ) then sim:destroy() end -- sim:destroy()
	if sim:isGUI( "new_game_button_pressed" ) then r = ENUM_GAME end
	if sim:isGUI( "high_scores_button_pressed" ) then r = ENUM_SCORE end

	sim:update()
	return r
end

-- called when changing state_menu
function state_menu:transition ( i ) -- transition to state_menu v
	print "[state_menu] transition"
	-- if self.time > 50 then print "..." end
end
