-- xenjine layer 2  : statemachine tutorial
-- c2007 : lukas irwin : sysop [ at ] xhrit.com
-- tutorial_statemachine.module

-- first code a state machine in lua using only the basic exposed xenjine functions. then use the low level state machine to do it all for you, just like the keyboard and gui.

print "starting tutorial statemachine"

ENUM_MENU = 1
ENUM_GAME = 2
ENUM_SCORE =3

-- TODO sort out this load / require junk.
a = loadfile "modules/tutorial_statemachine/statemachine.lua"
b = loadfile "modules/tutorial_statemachine/state.lua"
c = loadfile "modules/tutorial_statemachine/state_menu.lua"
d = loadfile "modules/tutorial_statemachine/state_game.lua"
e = loadfile "modules/tutorial_statemachine/state_scores.lua"

a() b() c() d() e() -- can i do this? or rather, SHOULD i do this? there has to be a better way!

-- function doload(n)
-- 	t = loadfile n
-- 	t()
-- end

-- required
function init()
	-- print "[tutorial_statemachine] init statemachine tutorial"
	sim = xcore.xsimulation ( xcore.XDT_OPENGL , 800, 600, 16, false, false, false )

	-- print "[tutorial_statemachine] new statemachine"
	fsm = statemachine:new() -- initalize state machine

	-- print "[tutorial_statemachine] new states"
	menu = state_menu:new()
	game = state_game:new()
	scores = state_scores:new()

	-- print "[tutorial_statemachine] add states to fsm"
	-- print ("[tutorial_statemachine] count: " .. fsm:count())
	fsm:addState( state_menu )
	fsm:addState( state_game )
	fsm:addState( state_scores )
	-- print ("[tutorial_statemachine] count: " .. fsm:count())

	-- print "[tutorial_statemachine] set default state"
	fsm:setDefault( ENUM_MENU )

	-- make it so you can exit the demo
	sim:bindkey ( "key_pressed_exit_state",  xcore.XKEY_ESCAPE  )
	
end

-- required
function render()
	-- print "[tutorial_statemachine] render"
	sim:render()
	-- print "[tutorial_statemachine] /render"
end

-- required
function update()
	-- print "[tutorial_statemachine] update"
	fsm:step()
	-- print "[tutorial_statemachine] /update"
end

-- end of file